
from cosmospy import Transaction, privkey_to_address
import cosmospy


class L2Transaction(cosmospy.Transaction):
    def __init__(self, *, privkey: bytes, account_num: int, sequence: int, fee: int, gas: int):
        super().__init__(privkey=privkey, account_num=account_num,
                         sequence=sequence, fee=fee, gas=gas)

    def add_l3_node(self, priv_key, node_pubkey, *options):
        transfer = {
            "type": "voter/MsgCreateL3Node",
            "value": {
                "creator": cosmospy.privkey_to_address(priv_key),
                "publicKey": node_pubkey,
                "options": options,
            },
        }
        self._msgs.append(transfer)
