import httpx
import json
from cosmospy import generate_wallet, BIP32DerivationError, seed_to_privkey, privkey_to_pubkey, pubkey_to_address, Transaction
from unittest.mock import Mock
from google.protobuf.json_format import Parse
from proto.l_3_node_pb2 import L3Node


def sendTx():
    privkey = bytes.fromhex(
        "6dcd05d7ac71e09d3cf7da666709ebd59362486ff9e99db0e8bc663570515afa")
    pubkey = privkey_to_pubkey(privkey)
    addr = pubkey_to_address(pubkey)

    unordered_sign_message = {
        "chain_id": "",
        "account_number": "1",
        "fee": {"gas": "0", "amount": [{"amount": "0", "denom": ""}]},
        "memo": "",
        "sequence": "0",
        "msgs": [
            {
                "type": "/cosmonaut.voter.voter.MsgCreateL3Node",
                "value": {
                    "creator": addr,
                    "title": "newNode",
                    "options": [
                        "nodeOptions"
                    ]
                },
            }
        ],
    }

    dummy_num = 1337

    tx = Transaction(
        privkey=privkey,
        account_num=dummy_num,
        sequence=dummy_num,
        fee=dummy_num,
        gas=dummy_num,
        memo="",
        chain_id="",
        sync_mode="sync",
    )

    sign = tx._get_sign_message = Mock(return_value=unordered_sign_message)
    print(sign)

    print("6")

    tx_result = tx._sign()
    print(tx_result)

    pushable_tx = tx.get_pushable()
    print("9")

    print(pushable_tx)

    print("10")

    sign_tx = {
        "jsonrpc": "2.0",
        "id": "434421454576",
        "method": "broadcast_tx_sync",
        "params":
            {
                "path": "cosmonaut.voter.voter.MsgCreateL3Node",
                "data": pushable_tx,
                "prove": False
            }
    }

    # api_base_url = "http://159.223.19.171:26657/cosmonaut.voter.voter.MsgCreateL3Node"
    # curl --header "Content-Type: application/json" --request POST --data ''{"jsonrpc":"2.0","id":434421454576,"method":"abci_query",
    # "params":{"path":"/cosmos.auth.v1beta1.Query/Account",
    # "data":"0a2d636f736d6f73317035767267337073643238387a3266643535336776613578756d7576736172637a6d35753435","prove":false}}''
    # 159.223.19.171:26657
    rest_api = "http://159.223.19.171:1317/cosmos/tx/v1beta1/txs"
    tendermint_api = "http://159.223.19.171:26657/"

    message = Parse(json.dumps(sign_tx), L3Node())
    channel =

    print(f'L3Node {message}')
    res = httpx.post(rest_api, data=message)

    print(res)

    return


if __name__ == '__main__':
    print("Start")
    sendTx()
