import { StdFee } from "@cosmjs/launchpad";
import { OfflineSigner, EncodeObject } from "@cosmjs/proto-signing";
import { Api } from "./rest";
import { MsgUpdateRollupDigest } from "./types/voter/tx";
import { MsgCreateMessage } from "./types/voter/tx";
import { MsgDeleteRollup } from "./types/voter/tx";
import { MsgDeleteMessage } from "./types/voter/tx";
import { MsgDeleteL3Node } from "./types/voter/tx";
import { MsgDeleteRollupDigest } from "./types/voter/tx";
import { MsgCreateL3Node } from "./types/voter/tx";
import { MsgUpdateL3Node } from "./types/voter/tx";
import { MsgUpdateAttachedUser } from "./types/voter/tx";
import { MsgDeleteAttachedUser } from "./types/voter/tx";
import { MsgCreateAttachedUser } from "./types/voter/tx";
import { MsgUpdateMessage } from "./types/voter/tx";
import { MsgUpdateRollup } from "./types/voter/tx";
import { MsgCreateRollupDigest } from "./types/voter/tx";
import { MsgCreateRollup } from "./types/voter/tx";
export declare const MissingWalletError: Error;
interface TxClientOptions {
    addr: string;
}
interface SignAndBroadcastOptions {
    fee: StdFee;
    memo?: string;
}
declare const txClient: (wallet: OfflineSigner, { addr: addr }?: TxClientOptions) => Promise<{
    signAndBroadcast: (msgs: EncodeObject[], { fee, memo }?: SignAndBroadcastOptions) => Promise<import("@cosmjs/stargate").BroadcastTxResponse>;
    msgUpdateRollupDigest: (data: MsgUpdateRollupDigest) => EncodeObject;
    msgCreateMessage: (data: MsgCreateMessage) => EncodeObject;
    msgDeleteRollup: (data: MsgDeleteRollup) => EncodeObject;
    msgDeleteMessage: (data: MsgDeleteMessage) => EncodeObject;
    msgDeleteL3Node: (data: MsgDeleteL3Node) => EncodeObject;
    msgDeleteRollupDigest: (data: MsgDeleteRollupDigest) => EncodeObject;
    msgCreateL3Node: (data: MsgCreateL3Node) => EncodeObject;
    msgUpdateL3Node: (data: MsgUpdateL3Node) => EncodeObject;
    msgUpdateAttachedUser: (data: MsgUpdateAttachedUser) => EncodeObject;
    msgDeleteAttachedUser: (data: MsgDeleteAttachedUser) => EncodeObject;
    msgCreateAttachedUser: (data: MsgCreateAttachedUser) => EncodeObject;
    msgUpdateMessage: (data: MsgUpdateMessage) => EncodeObject;
    msgUpdateRollup: (data: MsgUpdateRollup) => EncodeObject;
    msgCreateRollupDigest: (data: MsgCreateRollupDigest) => EncodeObject;
    msgCreateRollup: (data: MsgCreateRollup) => EncodeObject;
}>;
interface QueryClientOptions {
    addr: string;
}
declare const queryClient: ({ addr: addr }?: QueryClientOptions) => Promise<Api<unknown>>;
export { txClient, queryClient, };
