/* eslint-disable */
/* tslint:disable */
/*
 * ---------------------------------------------------------------
 * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
 * ##                                                           ##
 * ## AUTHOR: acacode                                           ##
 * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
 * ---------------------------------------------------------------
 */

export interface ProtobufAny {
  "@type"?: string;
}

export interface RpcStatus {
  /** @format int32 */
  code?: number;
  message?: string;
  details?: ProtobufAny[];
}

/**
* message SomeRequest {
         Foo some_parameter = 1;
         PageRequest pagination = 2;
 }
*/
export interface V1Beta1PageRequest {
  /**
   * key is a value returned in PageResponse.next_key to begin
   * querying the next page most efficiently. Only one of offset or key
   * should be set.
   * @format byte
   */
  key?: string;

  /**
   * offset is a numeric offset that can be used when key is unavailable.
   * It is less efficient than using key. Only one of offset or key should
   * be set.
   * @format uint64
   */
  offset?: string;

  /**
   * limit is the total number of results to be returned in the result page.
   * If left empty it will default to a value to be set by each app.
   * @format uint64
   */
  limit?: string;

  /**
   * count_total is set to true  to indicate that the result set should include
   * a count of the total number of items available for pagination in UIs.
   * count_total is only respected when offset is used. It is ignored when key
   * is set.
   */
  countTotal?: boolean;

  /** reverse is set to true if results are to be returned in the descending order. */
  reverse?: boolean;
}

/**
* PageResponse is to be embedded in gRPC response messages where the
corresponding request message has used PageRequest.

 message SomeResponse {
         repeated Bar results = 1;
         PageResponse page = 2;
 }
*/
export interface V1Beta1PageResponse {
  /** @format byte */
  nextKey?: string;

  /** @format uint64 */
  total?: string;
}

export interface VoterAttachedUser {
  /** @format int32 */
  iidapId?: number;

  /** @format int32 */
  account?: number;
  userName?: string;
  creator?: string;
}

export interface VoterL3Node {
  /** @format uint64 */
  id?: string;
  publicKey?: string;
  options?: string[];
  creator?: string;
}

export interface VoterMessage {
  /** @format uint64 */
  id?: string;
  status?: string;
  name?: string;
  data?: string[];
  creator?: string;
}

export type VoterMsgCreateAttachedUserResponse = object;

export interface VoterMsgCreateL3NodeResponse {
  /** @format uint64 */
  id?: string;
}

export interface VoterMsgCreateMessageResponse {
  /** @format uint64 */
  id?: string;
}

export interface VoterMsgCreateRollupDigestResponse {
  /** @format uint64 */
  id?: string;
}

export interface VoterMsgCreateRollupResponse {
  /** @format uint64 */
  id?: string;
}

export type VoterMsgDeleteAttachedUserResponse = object;

export type VoterMsgDeleteL3NodeResponse = object;

export type VoterMsgDeleteMessageResponse = object;

export type VoterMsgDeleteRollupDigestResponse = object;

export type VoterMsgDeleteRollupResponse = object;

export type VoterMsgUpdateAttachedUserResponse = object;

export type VoterMsgUpdateL3NodeResponse = object;

export type VoterMsgUpdateMessageResponse = object;

export type VoterMsgUpdateRollupDigestResponse = object;

export type VoterMsgUpdateRollupResponse = object;

export interface VoterQueryAllAttachedUserResponse {
  attachedUser?: VoterAttachedUser[];

  /**
   * PageResponse is to be embedded in gRPC response messages where the
   * corresponding request message has used PageRequest.
   *
   *  message SomeResponse {
   *          repeated Bar results = 1;
   *          PageResponse page = 2;
   *  }
   */
  pagination?: V1Beta1PageResponse;
}

export interface VoterQueryAllL3NodeResponse {
  L3Node?: VoterL3Node[];

  /**
   * PageResponse is to be embedded in gRPC response messages where the
   * corresponding request message has used PageRequest.
   *
   *  message SomeResponse {
   *          repeated Bar results = 1;
   *          PageResponse page = 2;
   *  }
   */
  pagination?: V1Beta1PageResponse;
}

export interface VoterQueryAllMessageResponse {
  Message?: VoterMessage[];

  /**
   * PageResponse is to be embedded in gRPC response messages where the
   * corresponding request message has used PageRequest.
   *
   *  message SomeResponse {
   *          repeated Bar results = 1;
   *          PageResponse page = 2;
   *  }
   */
  pagination?: V1Beta1PageResponse;
}

export interface VoterQueryAllRollupDigestResponse {
  RollupDigest?: VoterRollupDigest[];

  /**
   * PageResponse is to be embedded in gRPC response messages where the
   * corresponding request message has used PageRequest.
   *
   *  message SomeResponse {
   *          repeated Bar results = 1;
   *          PageResponse page = 2;
   *  }
   */
  pagination?: V1Beta1PageResponse;
}

export interface VoterQueryAllRollupResponse {
  Rollup?: VoterRollup[];

  /**
   * PageResponse is to be embedded in gRPC response messages where the
   * corresponding request message has used PageRequest.
   *
   *  message SomeResponse {
   *          repeated Bar results = 1;
   *          PageResponse page = 2;
   *  }
   */
  pagination?: V1Beta1PageResponse;
}

export interface VoterQueryGetAttachedUserResponse {
  attachedUser?: VoterAttachedUser;
}

export interface VoterQueryGetL3NodeResponse {
  L3Node?: VoterL3Node;
}

export interface VoterQueryGetMessageResponse {
  Message?: VoterMessage;
}

export interface VoterQueryGetRollupDigestResponse {
  RollupDigest?: VoterRollupDigest;
}

export interface VoterQueryGetRollupResponse {
  Rollup?: VoterRollup;
}

export interface VoterRollup {
  /** @format uint64 */
  id?: string;
  prevHash?: string;
  currentHash?: string;
  dsUri?: string;
  inbox?: string[];
  creator?: string;
}

export interface VoterRollupDigest {
  /** @format uint64 */
  id?: string;
  dsUri?: string;
  currentHash?: string;
  status?: string;
  creator?: string;
}

export type QueryParamsType = Record<string | number, any>;
export type ResponseFormat = keyof Omit<Body, "body" | "bodyUsed">;

export interface FullRequestParams extends Omit<RequestInit, "body"> {
  /** set parameter to `true` for call `securityWorker` for this request */
  secure?: boolean;
  /** request path */
  path: string;
  /** content type of request body */
  type?: ContentType;
  /** query params */
  query?: QueryParamsType;
  /** format of response (i.e. response.json() -> format: "json") */
  format?: keyof Omit<Body, "body" | "bodyUsed">;
  /** request body */
  body?: unknown;
  /** base url */
  baseUrl?: string;
  /** request cancellation token */
  cancelToken?: CancelToken;
}

export type RequestParams = Omit<FullRequestParams, "body" | "method" | "query" | "path">;

export interface ApiConfig<SecurityDataType = unknown> {
  baseUrl?: string;
  baseApiParams?: Omit<RequestParams, "baseUrl" | "cancelToken" | "signal">;
  securityWorker?: (securityData: SecurityDataType) => RequestParams | void;
}

export interface HttpResponse<D extends unknown, E extends unknown = unknown> extends Response {
  data: D;
  error: E;
}

type CancelToken = Symbol | string | number;

export enum ContentType {
  Json = "application/json",
  FormData = "multipart/form-data",
  UrlEncoded = "application/x-www-form-urlencoded",
}

export class HttpClient<SecurityDataType = unknown> {
  public baseUrl: string = "";
  private securityData: SecurityDataType = null as any;
  private securityWorker: null | ApiConfig<SecurityDataType>["securityWorker"] = null;
  private abortControllers = new Map<CancelToken, AbortController>();

  private baseApiParams: RequestParams = {
    credentials: "same-origin",
    headers: {},
    redirect: "follow",
    referrerPolicy: "no-referrer",
  };

  constructor(apiConfig: ApiConfig<SecurityDataType> = {}) {
    Object.assign(this, apiConfig);
  }

  public setSecurityData = (data: SecurityDataType) => {
    this.securityData = data;
  };

  private addQueryParam(query: QueryParamsType, key: string) {
    const value = query[key];

    return (
      encodeURIComponent(key) +
      "=" +
      encodeURIComponent(Array.isArray(value) ? value.join(",") : typeof value === "number" ? value : `${value}`)
    );
  }

  protected toQueryString(rawQuery?: QueryParamsType): string {
    const query = rawQuery || {};
    const keys = Object.keys(query).filter((key) => "undefined" !== typeof query[key]);
    return keys
      .map((key) =>
        typeof query[key] === "object" && !Array.isArray(query[key])
          ? this.toQueryString(query[key] as QueryParamsType)
          : this.addQueryParam(query, key),
      )
      .join("&");
  }

  protected addQueryParams(rawQuery?: QueryParamsType): string {
    const queryString = this.toQueryString(rawQuery);
    return queryString ? `?${queryString}` : "";
  }

  private contentFormatters: Record<ContentType, (input: any) => any> = {
    [ContentType.Json]: (input: any) =>
      input !== null && (typeof input === "object" || typeof input === "string") ? JSON.stringify(input) : input,
    [ContentType.FormData]: (input: any) =>
      Object.keys(input || {}).reduce((data, key) => {
        data.append(key, input[key]);
        return data;
      }, new FormData()),
    [ContentType.UrlEncoded]: (input: any) => this.toQueryString(input),
  };

  private mergeRequestParams(params1: RequestParams, params2?: RequestParams): RequestParams {
    return {
      ...this.baseApiParams,
      ...params1,
      ...(params2 || {}),
      headers: {
        ...(this.baseApiParams.headers || {}),
        ...(params1.headers || {}),
        ...((params2 && params2.headers) || {}),
      },
    };
  }

  private createAbortSignal = (cancelToken: CancelToken): AbortSignal | undefined => {
    if (this.abortControllers.has(cancelToken)) {
      const abortController = this.abortControllers.get(cancelToken);
      if (abortController) {
        return abortController.signal;
      }
      return void 0;
    }

    const abortController = new AbortController();
    this.abortControllers.set(cancelToken, abortController);
    return abortController.signal;
  };

  public abortRequest = (cancelToken: CancelToken) => {
    const abortController = this.abortControllers.get(cancelToken);

    if (abortController) {
      abortController.abort();
      this.abortControllers.delete(cancelToken);
    }
  };

  public request = <T = any, E = any>({
    body,
    secure,
    path,
    type,
    query,
    format = "json",
    baseUrl,
    cancelToken,
    ...params
  }: FullRequestParams): Promise<HttpResponse<T, E>> => {
    const secureParams = (secure && this.securityWorker && this.securityWorker(this.securityData)) || {};
    const requestParams = this.mergeRequestParams(params, secureParams);
    const queryString = query && this.toQueryString(query);
    const payloadFormatter = this.contentFormatters[type || ContentType.Json];

    return fetch(`${baseUrl || this.baseUrl || ""}${path}${queryString ? `?${queryString}` : ""}`, {
      ...requestParams,
      headers: {
        ...(type && type !== ContentType.FormData ? { "Content-Type": type } : {}),
        ...(requestParams.headers || {}),
      },
      signal: cancelToken ? this.createAbortSignal(cancelToken) : void 0,
      body: typeof body === "undefined" || body === null ? null : payloadFormatter(body),
    }).then(async (response) => {
      const r = response as HttpResponse<T, E>;
      r.data = (null as unknown) as T;
      r.error = (null as unknown) as E;

      const data = await response[format]()
        .then((data) => {
          if (r.ok) {
            r.data = data;
          } else {
            r.error = data;
          }
          return r;
        })
        .catch((e) => {
          r.error = e;
          return r;
        });

      if (cancelToken) {
        this.abortControllers.delete(cancelToken);
      }

      if (!response.ok) throw data;
      return data;
    });
  };
}

/**
 * @title voter/attached_user.proto
 * @version version not set
 */
export class Api<SecurityDataType extends unknown> extends HttpClient<SecurityDataType> {
  /**
   * No description
   *
   * @tags Query
   * @name QueryAttachedUserAll
   * @summary Queries a list of attachedUser items.
   * @request GET:/cosmonaut/voter/voter/attachedUser
   */
  queryAttachedUserAll = (
    query?: {
      "pagination.key"?: string;
      "pagination.offset"?: string;
      "pagination.limit"?: string;
      "pagination.countTotal"?: boolean;
      "pagination.reverse"?: boolean;
    },
    params: RequestParams = {},
  ) =>
    this.request<VoterQueryAllAttachedUserResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/attachedUser`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryAttachedUser
   * @summary Queries a attachedUser by index.
   * @request GET:/cosmonaut/voter/voter/attachedUser/{iidapId}/{account}
   */
  queryAttachedUser = (iidapId: number, account: number, params: RequestParams = {}) =>
    this.request<VoterQueryGetAttachedUserResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/attachedUser/${iidapId}/${account}`,
      method: "GET",
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryL3NodeAll
   * @summary Queries a list of l3Node items.
   * @request GET:/cosmonaut/voter/voter/l3Node
   */
  queryL3NodeAll = (
    query?: {
      "pagination.key"?: string;
      "pagination.offset"?: string;
      "pagination.limit"?: string;
      "pagination.countTotal"?: boolean;
      "pagination.reverse"?: boolean;
    },
    params: RequestParams = {},
  ) =>
    this.request<VoterQueryAllL3NodeResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/l3Node`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryL3Node
   * @summary Queries a l3Node by id.
   * @request GET:/cosmonaut/voter/voter/l3Node/{id}
   */
  queryL3Node = (id: string, params: RequestParams = {}) =>
    this.request<VoterQueryGetL3NodeResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/l3Node/${id}`,
      method: "GET",
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryMessageAll
   * @summary Queries a list of message items.
   * @request GET:/cosmonaut/voter/voter/message
   */
  queryMessageAll = (
    query?: {
      "pagination.key"?: string;
      "pagination.offset"?: string;
      "pagination.limit"?: string;
      "pagination.countTotal"?: boolean;
      "pagination.reverse"?: boolean;
    },
    params: RequestParams = {},
  ) =>
    this.request<VoterQueryAllMessageResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/message`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryMessage
   * @summary Queries a message by id.
   * @request GET:/cosmonaut/voter/voter/message/{id}
   */
  queryMessage = (id: string, params: RequestParams = {}) =>
    this.request<VoterQueryGetMessageResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/message/${id}`,
      method: "GET",
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryRollupAll
   * @summary Queries a list of rollup items.
   * @request GET:/cosmonaut/voter/voter/rollup
   */
  queryRollupAll = (
    query?: {
      "pagination.key"?: string;
      "pagination.offset"?: string;
      "pagination.limit"?: string;
      "pagination.countTotal"?: boolean;
      "pagination.reverse"?: boolean;
    },
    params: RequestParams = {},
  ) =>
    this.request<VoterQueryAllRollupResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/rollup`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryRollup
   * @summary Queries a rollup by id.
   * @request GET:/cosmonaut/voter/voter/rollup/{id}
   */
  queryRollup = (id: string, params: RequestParams = {}) =>
    this.request<VoterQueryGetRollupResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/rollup/${id}`,
      method: "GET",
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryRollupDigestAll
   * @summary Queries a list of rollupDigest items.
   * @request GET:/cosmonaut/voter/voter/rollupDigest
   */
  queryRollupDigestAll = (
    query?: {
      "pagination.key"?: string;
      "pagination.offset"?: string;
      "pagination.limit"?: string;
      "pagination.countTotal"?: boolean;
      "pagination.reverse"?: boolean;
    },
    params: RequestParams = {},
  ) =>
    this.request<VoterQueryAllRollupDigestResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/rollupDigest`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });

  /**
   * No description
   *
   * @tags Query
   * @name QueryRollupDigest
   * @summary Queries a rollupDigest by id.
   * @request GET:/cosmonaut/voter/voter/rollupDigest/{id}
   */
  queryRollupDigest = (id: string, params: RequestParams = {}) =>
    this.request<VoterQueryGetRollupDigestResponse, RpcStatus>({
      path: `/cosmonaut/voter/voter/rollupDigest/${id}`,
      method: "GET",
      format: "json",
      ...params,
    });
}
