/* eslint-disable */
import { Reader, util, configure, Writer } from "protobufjs/minimal";
import * as Long from "long";
import { Rollup } from "../voter/rollup";
import { PageRequest, PageResponse, } from "../cosmos/base/query/v1beta1/pagination";
import { Message } from "../voter/message";
import { L3Node } from "../voter/l_3_node";
import { AttachedUser } from "../voter/attached_user";
import { RollupDigest } from "../voter/rollup_digest";
export const protobufPackage = "cosmonaut.voter.voter";
const baseQueryGetRollupRequest = { id: 0 };
export const QueryGetRollupRequest = {
    encode(message, writer = Writer.create()) {
        if (message.id !== 0) {
            writer.uint32(8).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryGetRollupRequest };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryGetRollupRequest };
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryGetRollupRequest };
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseQueryGetRollupResponse = {};
export const QueryGetRollupResponse = {
    encode(message, writer = Writer.create()) {
        if (message.Rollup !== undefined) {
            Rollup.encode(message.Rollup, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryGetRollupResponse };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.Rollup = Rollup.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryGetRollupResponse };
        if (object.Rollup !== undefined && object.Rollup !== null) {
            message.Rollup = Rollup.fromJSON(object.Rollup);
        }
        else {
            message.Rollup = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.Rollup !== undefined &&
            (obj.Rollup = message.Rollup ? Rollup.toJSON(message.Rollup) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryGetRollupResponse };
        if (object.Rollup !== undefined && object.Rollup !== null) {
            message.Rollup = Rollup.fromPartial(object.Rollup);
        }
        else {
            message.Rollup = undefined;
        }
        return message;
    },
};
const baseQueryAllRollupRequest = {};
export const QueryAllRollupRequest = {
    encode(message, writer = Writer.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryAllRollupRequest };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryAllRollupRequest };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryAllRollupRequest };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryAllRollupResponse = {};
export const QueryAllRollupResponse = {
    encode(message, writer = Writer.create()) {
        for (const v of message.Rollup) {
            Rollup.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryAllRollupResponse };
        message.Rollup = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.Rollup.push(Rollup.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryAllRollupResponse };
        message.Rollup = [];
        if (object.Rollup !== undefined && object.Rollup !== null) {
            for (const e of object.Rollup) {
                message.Rollup.push(Rollup.fromJSON(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        if (message.Rollup) {
            obj.Rollup = message.Rollup.map((e) => e ? Rollup.toJSON(e) : undefined);
        }
        else {
            obj.Rollup = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryAllRollupResponse };
        message.Rollup = [];
        if (object.Rollup !== undefined && object.Rollup !== null) {
            for (const e of object.Rollup) {
                message.Rollup.push(Rollup.fromPartial(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryGetMessageRequest = { id: 0 };
export const QueryGetMessageRequest = {
    encode(message, writer = Writer.create()) {
        if (message.id !== 0) {
            writer.uint32(8).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryGetMessageRequest };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryGetMessageRequest };
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryGetMessageRequest };
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseQueryGetMessageResponse = {};
export const QueryGetMessageResponse = {
    encode(message, writer = Writer.create()) {
        if (message.Message !== undefined) {
            Message.encode(message.Message, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryGetMessageResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.Message = Message.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryGetMessageResponse,
        };
        if (object.Message !== undefined && object.Message !== null) {
            message.Message = Message.fromJSON(object.Message);
        }
        else {
            message.Message = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.Message !== undefined &&
            (obj.Message = message.Message
                ? Message.toJSON(message.Message)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryGetMessageResponse,
        };
        if (object.Message !== undefined && object.Message !== null) {
            message.Message = Message.fromPartial(object.Message);
        }
        else {
            message.Message = undefined;
        }
        return message;
    },
};
const baseQueryAllMessageRequest = {};
export const QueryAllMessageRequest = {
    encode(message, writer = Writer.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryAllMessageRequest };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryAllMessageRequest };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryAllMessageRequest };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryAllMessageResponse = {};
export const QueryAllMessageResponse = {
    encode(message, writer = Writer.create()) {
        for (const v of message.Message) {
            Message.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryAllMessageResponse,
        };
        message.Message = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.Message.push(Message.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryAllMessageResponse,
        };
        message.Message = [];
        if (object.Message !== undefined && object.Message !== null) {
            for (const e of object.Message) {
                message.Message.push(Message.fromJSON(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        if (message.Message) {
            obj.Message = message.Message.map((e) => e ? Message.toJSON(e) : undefined);
        }
        else {
            obj.Message = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryAllMessageResponse,
        };
        message.Message = [];
        if (object.Message !== undefined && object.Message !== null) {
            for (const e of object.Message) {
                message.Message.push(Message.fromPartial(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryGetL3NodeRequest = { id: 0 };
export const QueryGetL3NodeRequest = {
    encode(message, writer = Writer.create()) {
        if (message.id !== 0) {
            writer.uint32(8).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryGetL3NodeRequest };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryGetL3NodeRequest };
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryGetL3NodeRequest };
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseQueryGetL3NodeResponse = {};
export const QueryGetL3NodeResponse = {
    encode(message, writer = Writer.create()) {
        if (message.L3Node !== undefined) {
            L3Node.encode(message.L3Node, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryGetL3NodeResponse };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.L3Node = L3Node.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryGetL3NodeResponse };
        if (object.L3Node !== undefined && object.L3Node !== null) {
            message.L3Node = L3Node.fromJSON(object.L3Node);
        }
        else {
            message.L3Node = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.L3Node !== undefined &&
            (obj.L3Node = message.L3Node ? L3Node.toJSON(message.L3Node) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryGetL3NodeResponse };
        if (object.L3Node !== undefined && object.L3Node !== null) {
            message.L3Node = L3Node.fromPartial(object.L3Node);
        }
        else {
            message.L3Node = undefined;
        }
        return message;
    },
};
const baseQueryAllL3NodeRequest = {};
export const QueryAllL3NodeRequest = {
    encode(message, writer = Writer.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryAllL3NodeRequest };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryAllL3NodeRequest };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryAllL3NodeRequest };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryAllL3NodeResponse = {};
export const QueryAllL3NodeResponse = {
    encode(message, writer = Writer.create()) {
        for (const v of message.L3Node) {
            L3Node.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseQueryAllL3NodeResponse };
        message.L3Node = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.L3Node.push(L3Node.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseQueryAllL3NodeResponse };
        message.L3Node = [];
        if (object.L3Node !== undefined && object.L3Node !== null) {
            for (const e of object.L3Node) {
                message.L3Node.push(L3Node.fromJSON(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        if (message.L3Node) {
            obj.L3Node = message.L3Node.map((e) => e ? L3Node.toJSON(e) : undefined);
        }
        else {
            obj.L3Node = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseQueryAllL3NodeResponse };
        message.L3Node = [];
        if (object.L3Node !== undefined && object.L3Node !== null) {
            for (const e of object.L3Node) {
                message.L3Node.push(L3Node.fromPartial(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryGetAttachedUserRequest = { iidapId: 0, account: 0 };
export const QueryGetAttachedUserRequest = {
    encode(message, writer = Writer.create()) {
        if (message.iidapId !== 0) {
            writer.uint32(8).int32(message.iidapId);
        }
        if (message.account !== 0) {
            writer.uint32(16).int32(message.account);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryGetAttachedUserRequest,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.iidapId = reader.int32();
                    break;
                case 2:
                    message.account = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryGetAttachedUserRequest,
        };
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = Number(object.iidapId);
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = Number(object.account);
        }
        else {
            message.account = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.iidapId !== undefined && (obj.iidapId = message.iidapId);
        message.account !== undefined && (obj.account = message.account);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryGetAttachedUserRequest,
        };
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = object.iidapId;
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = object.account;
        }
        else {
            message.account = 0;
        }
        return message;
    },
};
const baseQueryGetAttachedUserResponse = {};
export const QueryGetAttachedUserResponse = {
    encode(message, writer = Writer.create()) {
        if (message.attachedUser !== undefined) {
            AttachedUser.encode(message.attachedUser, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryGetAttachedUserResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.attachedUser = AttachedUser.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryGetAttachedUserResponse,
        };
        if (object.attachedUser !== undefined && object.attachedUser !== null) {
            message.attachedUser = AttachedUser.fromJSON(object.attachedUser);
        }
        else {
            message.attachedUser = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.attachedUser !== undefined &&
            (obj.attachedUser = message.attachedUser
                ? AttachedUser.toJSON(message.attachedUser)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryGetAttachedUserResponse,
        };
        if (object.attachedUser !== undefined && object.attachedUser !== null) {
            message.attachedUser = AttachedUser.fromPartial(object.attachedUser);
        }
        else {
            message.attachedUser = undefined;
        }
        return message;
    },
};
const baseQueryAllAttachedUserRequest = {};
export const QueryAllAttachedUserRequest = {
    encode(message, writer = Writer.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryAllAttachedUserRequest,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryAllAttachedUserRequest,
        };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryAllAttachedUserRequest,
        };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryAllAttachedUserResponse = {};
export const QueryAllAttachedUserResponse = {
    encode(message, writer = Writer.create()) {
        for (const v of message.attachedUser) {
            AttachedUser.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryAllAttachedUserResponse,
        };
        message.attachedUser = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.attachedUser.push(AttachedUser.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryAllAttachedUserResponse,
        };
        message.attachedUser = [];
        if (object.attachedUser !== undefined && object.attachedUser !== null) {
            for (const e of object.attachedUser) {
                message.attachedUser.push(AttachedUser.fromJSON(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        if (message.attachedUser) {
            obj.attachedUser = message.attachedUser.map((e) => e ? AttachedUser.toJSON(e) : undefined);
        }
        else {
            obj.attachedUser = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryAllAttachedUserResponse,
        };
        message.attachedUser = [];
        if (object.attachedUser !== undefined && object.attachedUser !== null) {
            for (const e of object.attachedUser) {
                message.attachedUser.push(AttachedUser.fromPartial(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryGetRollupDigestRequest = { id: 0 };
export const QueryGetRollupDigestRequest = {
    encode(message, writer = Writer.create()) {
        if (message.id !== 0) {
            writer.uint32(8).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryGetRollupDigestRequest,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryGetRollupDigestRequest,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryGetRollupDigestRequest,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseQueryGetRollupDigestResponse = {};
export const QueryGetRollupDigestResponse = {
    encode(message, writer = Writer.create()) {
        if (message.RollupDigest !== undefined) {
            RollupDigest.encode(message.RollupDigest, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryGetRollupDigestResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.RollupDigest = RollupDigest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryGetRollupDigestResponse,
        };
        if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
            message.RollupDigest = RollupDigest.fromJSON(object.RollupDigest);
        }
        else {
            message.RollupDigest = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.RollupDigest !== undefined &&
            (obj.RollupDigest = message.RollupDigest
                ? RollupDigest.toJSON(message.RollupDigest)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryGetRollupDigestResponse,
        };
        if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
            message.RollupDigest = RollupDigest.fromPartial(object.RollupDigest);
        }
        else {
            message.RollupDigest = undefined;
        }
        return message;
    },
};
const baseQueryAllRollupDigestRequest = {};
export const QueryAllRollupDigestRequest = {
    encode(message, writer = Writer.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryAllRollupDigestRequest,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryAllRollupDigestRequest,
        };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryAllRollupDigestRequest,
        };
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
const baseQueryAllRollupDigestResponse = {};
export const QueryAllRollupDigestResponse = {
    encode(message, writer = Writer.create()) {
        for (const v of message.RollupDigest) {
            RollupDigest.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseQueryAllRollupDigestResponse,
        };
        message.RollupDigest = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.RollupDigest.push(RollupDigest.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseQueryAllRollupDigestResponse,
        };
        message.RollupDigest = [];
        if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
            for (const e of object.RollupDigest) {
                message.RollupDigest.push(RollupDigest.fromJSON(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromJSON(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        if (message.RollupDigest) {
            obj.RollupDigest = message.RollupDigest.map((e) => e ? RollupDigest.toJSON(e) : undefined);
        }
        else {
            obj.RollupDigest = [];
        }
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? PageResponse.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseQueryAllRollupDigestResponse,
        };
        message.RollupDigest = [];
        if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
            for (const e of object.RollupDigest) {
                message.RollupDigest.push(RollupDigest.fromPartial(e));
            }
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        else {
            message.pagination = undefined;
        }
        return message;
    },
};
export class QueryClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
    }
    Rollup(request) {
        const data = QueryGetRollupRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "Rollup", data);
        return promise.then((data) => QueryGetRollupResponse.decode(new Reader(data)));
    }
    RollupAll(request) {
        const data = QueryAllRollupRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "RollupAll", data);
        return promise.then((data) => QueryAllRollupResponse.decode(new Reader(data)));
    }
    Message(request) {
        const data = QueryGetMessageRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "Message", data);
        return promise.then((data) => QueryGetMessageResponse.decode(new Reader(data)));
    }
    MessageAll(request) {
        const data = QueryAllMessageRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "MessageAll", data);
        return promise.then((data) => QueryAllMessageResponse.decode(new Reader(data)));
    }
    L3Node(request) {
        const data = QueryGetL3NodeRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "L3Node", data);
        return promise.then((data) => QueryGetL3NodeResponse.decode(new Reader(data)));
    }
    L3NodeAll(request) {
        const data = QueryAllL3NodeRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "L3NodeAll", data);
        return promise.then((data) => QueryAllL3NodeResponse.decode(new Reader(data)));
    }
    AttachedUser(request) {
        const data = QueryGetAttachedUserRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "AttachedUser", data);
        return promise.then((data) => QueryGetAttachedUserResponse.decode(new Reader(data)));
    }
    AttachedUserAll(request) {
        const data = QueryAllAttachedUserRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "AttachedUserAll", data);
        return promise.then((data) => QueryAllAttachedUserResponse.decode(new Reader(data)));
    }
    RollupDigest(request) {
        const data = QueryGetRollupDigestRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "RollupDigest", data);
        return promise.then((data) => QueryGetRollupDigestResponse.decode(new Reader(data)));
    }
    RollupDigestAll(request) {
        const data = QueryAllRollupDigestRequest.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Query", "RollupDigestAll", data);
        return promise.then((data) => QueryAllRollupDigestResponse.decode(new Reader(data)));
    }
}
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
function longToNumber(long) {
    if (long.gt(Number.MAX_SAFE_INTEGER)) {
        throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
    }
    return long.toNumber();
}
if (util.Long !== Long) {
    util.Long = Long;
    configure();
}
