/* eslint-disable */
import { Reader, util, configure, Writer } from "protobufjs/minimal";
import * as Long from "long";
import { Rollup } from "../voter/rollup";
import {
  PageRequest,
  PageResponse,
} from "../cosmos/base/query/v1beta1/pagination";
import { Message } from "../voter/message";
import { L3Node } from "../voter/l_3_node";
import { AttachedUser } from "../voter/attached_user";
import { RollupDigest } from "../voter/rollup_digest";

export const protobufPackage = "cosmonaut.voter.voter";

export interface QueryGetRollupRequest {
  id: number;
}

export interface QueryGetRollupResponse {
  Rollup: Rollup | undefined;
}

export interface QueryAllRollupRequest {
  pagination: PageRequest | undefined;
}

export interface QueryAllRollupResponse {
  Rollup: Rollup[];
  pagination: PageResponse | undefined;
}

export interface QueryGetMessageRequest {
  id: number;
}

export interface QueryGetMessageResponse {
  Message: Message | undefined;
}

export interface QueryAllMessageRequest {
  pagination: PageRequest | undefined;
}

export interface QueryAllMessageResponse {
  Message: Message[];
  pagination: PageResponse | undefined;
}

export interface QueryGetL3NodeRequest {
  id: number;
}

export interface QueryGetL3NodeResponse {
  L3Node: L3Node | undefined;
}

export interface QueryAllL3NodeRequest {
  pagination: PageRequest | undefined;
}

export interface QueryAllL3NodeResponse {
  L3Node: L3Node[];
  pagination: PageResponse | undefined;
}

export interface QueryGetAttachedUserRequest {
  iidapId: number;
  account: number;
}

export interface QueryGetAttachedUserResponse {
  attachedUser: AttachedUser | undefined;
}

export interface QueryAllAttachedUserRequest {
  pagination: PageRequest | undefined;
}

export interface QueryAllAttachedUserResponse {
  attachedUser: AttachedUser[];
  pagination: PageResponse | undefined;
}

export interface QueryGetRollupDigestRequest {
  id: number;
}

export interface QueryGetRollupDigestResponse {
  RollupDigest: RollupDigest | undefined;
}

export interface QueryAllRollupDigestRequest {
  pagination: PageRequest | undefined;
}

export interface QueryAllRollupDigestResponse {
  RollupDigest: RollupDigest[];
  pagination: PageResponse | undefined;
}

const baseQueryGetRollupRequest: object = { id: 0 };

export const QueryGetRollupRequest = {
  encode(
    message: QueryGetRollupRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryGetRollupRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryGetRollupRequest } as QueryGetRollupRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetRollupRequest {
    const message = { ...baseQueryGetRollupRequest } as QueryGetRollupRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: QueryGetRollupRequest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetRollupRequest>
  ): QueryGetRollupRequest {
    const message = { ...baseQueryGetRollupRequest } as QueryGetRollupRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseQueryGetRollupResponse: object = {};

export const QueryGetRollupResponse = {
  encode(
    message: QueryGetRollupResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.Rollup !== undefined) {
      Rollup.encode(message.Rollup, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryGetRollupResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryGetRollupResponse } as QueryGetRollupResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.Rollup = Rollup.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetRollupResponse {
    const message = { ...baseQueryGetRollupResponse } as QueryGetRollupResponse;
    if (object.Rollup !== undefined && object.Rollup !== null) {
      message.Rollup = Rollup.fromJSON(object.Rollup);
    } else {
      message.Rollup = undefined;
    }
    return message;
  },

  toJSON(message: QueryGetRollupResponse): unknown {
    const obj: any = {};
    message.Rollup !== undefined &&
      (obj.Rollup = message.Rollup ? Rollup.toJSON(message.Rollup) : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetRollupResponse>
  ): QueryGetRollupResponse {
    const message = { ...baseQueryGetRollupResponse } as QueryGetRollupResponse;
    if (object.Rollup !== undefined && object.Rollup !== null) {
      message.Rollup = Rollup.fromPartial(object.Rollup);
    } else {
      message.Rollup = undefined;
    }
    return message;
  },
};

const baseQueryAllRollupRequest: object = {};

export const QueryAllRollupRequest = {
  encode(
    message: QueryAllRollupRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryAllRollupRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryAllRollupRequest } as QueryAllRollupRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllRollupRequest {
    const message = { ...baseQueryAllRollupRequest } as QueryAllRollupRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllRollupRequest): unknown {
    const obj: any = {};
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageRequest.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllRollupRequest>
  ): QueryAllRollupRequest {
    const message = { ...baseQueryAllRollupRequest } as QueryAllRollupRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryAllRollupResponse: object = {};

export const QueryAllRollupResponse = {
  encode(
    message: QueryAllRollupResponse,
    writer: Writer = Writer.create()
  ): Writer {
    for (const v of message.Rollup) {
      Rollup.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(
        message.pagination,
        writer.uint32(18).fork()
      ).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryAllRollupResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryAllRollupResponse } as QueryAllRollupResponse;
    message.Rollup = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.Rollup.push(Rollup.decode(reader, reader.uint32()));
          break;
        case 2:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllRollupResponse {
    const message = { ...baseQueryAllRollupResponse } as QueryAllRollupResponse;
    message.Rollup = [];
    if (object.Rollup !== undefined && object.Rollup !== null) {
      for (const e of object.Rollup) {
        message.Rollup.push(Rollup.fromJSON(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllRollupResponse): unknown {
    const obj: any = {};
    if (message.Rollup) {
      obj.Rollup = message.Rollup.map((e) =>
        e ? Rollup.toJSON(e) : undefined
      );
    } else {
      obj.Rollup = [];
    }
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageResponse.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllRollupResponse>
  ): QueryAllRollupResponse {
    const message = { ...baseQueryAllRollupResponse } as QueryAllRollupResponse;
    message.Rollup = [];
    if (object.Rollup !== undefined && object.Rollup !== null) {
      for (const e of object.Rollup) {
        message.Rollup.push(Rollup.fromPartial(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryGetMessageRequest: object = { id: 0 };

export const QueryGetMessageRequest = {
  encode(
    message: QueryGetMessageRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryGetMessageRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryGetMessageRequest } as QueryGetMessageRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetMessageRequest {
    const message = { ...baseQueryGetMessageRequest } as QueryGetMessageRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: QueryGetMessageRequest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetMessageRequest>
  ): QueryGetMessageRequest {
    const message = { ...baseQueryGetMessageRequest } as QueryGetMessageRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseQueryGetMessageResponse: object = {};

export const QueryGetMessageResponse = {
  encode(
    message: QueryGetMessageResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.Message !== undefined) {
      Message.encode(message.Message, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryGetMessageResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryGetMessageResponse,
    } as QueryGetMessageResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.Message = Message.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetMessageResponse {
    const message = {
      ...baseQueryGetMessageResponse,
    } as QueryGetMessageResponse;
    if (object.Message !== undefined && object.Message !== null) {
      message.Message = Message.fromJSON(object.Message);
    } else {
      message.Message = undefined;
    }
    return message;
  },

  toJSON(message: QueryGetMessageResponse): unknown {
    const obj: any = {};
    message.Message !== undefined &&
      (obj.Message = message.Message
        ? Message.toJSON(message.Message)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetMessageResponse>
  ): QueryGetMessageResponse {
    const message = {
      ...baseQueryGetMessageResponse,
    } as QueryGetMessageResponse;
    if (object.Message !== undefined && object.Message !== null) {
      message.Message = Message.fromPartial(object.Message);
    } else {
      message.Message = undefined;
    }
    return message;
  },
};

const baseQueryAllMessageRequest: object = {};

export const QueryAllMessageRequest = {
  encode(
    message: QueryAllMessageRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryAllMessageRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryAllMessageRequest } as QueryAllMessageRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllMessageRequest {
    const message = { ...baseQueryAllMessageRequest } as QueryAllMessageRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllMessageRequest): unknown {
    const obj: any = {};
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageRequest.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllMessageRequest>
  ): QueryAllMessageRequest {
    const message = { ...baseQueryAllMessageRequest } as QueryAllMessageRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryAllMessageResponse: object = {};

export const QueryAllMessageResponse = {
  encode(
    message: QueryAllMessageResponse,
    writer: Writer = Writer.create()
  ): Writer {
    for (const v of message.Message) {
      Message.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(
        message.pagination,
        writer.uint32(18).fork()
      ).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryAllMessageResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryAllMessageResponse,
    } as QueryAllMessageResponse;
    message.Message = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.Message.push(Message.decode(reader, reader.uint32()));
          break;
        case 2:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllMessageResponse {
    const message = {
      ...baseQueryAllMessageResponse,
    } as QueryAllMessageResponse;
    message.Message = [];
    if (object.Message !== undefined && object.Message !== null) {
      for (const e of object.Message) {
        message.Message.push(Message.fromJSON(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllMessageResponse): unknown {
    const obj: any = {};
    if (message.Message) {
      obj.Message = message.Message.map((e) =>
        e ? Message.toJSON(e) : undefined
      );
    } else {
      obj.Message = [];
    }
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageResponse.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllMessageResponse>
  ): QueryAllMessageResponse {
    const message = {
      ...baseQueryAllMessageResponse,
    } as QueryAllMessageResponse;
    message.Message = [];
    if (object.Message !== undefined && object.Message !== null) {
      for (const e of object.Message) {
        message.Message.push(Message.fromPartial(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryGetL3NodeRequest: object = { id: 0 };

export const QueryGetL3NodeRequest = {
  encode(
    message: QueryGetL3NodeRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryGetL3NodeRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryGetL3NodeRequest } as QueryGetL3NodeRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetL3NodeRequest {
    const message = { ...baseQueryGetL3NodeRequest } as QueryGetL3NodeRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: QueryGetL3NodeRequest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetL3NodeRequest>
  ): QueryGetL3NodeRequest {
    const message = { ...baseQueryGetL3NodeRequest } as QueryGetL3NodeRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseQueryGetL3NodeResponse: object = {};

export const QueryGetL3NodeResponse = {
  encode(
    message: QueryGetL3NodeResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.L3Node !== undefined) {
      L3Node.encode(message.L3Node, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryGetL3NodeResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryGetL3NodeResponse } as QueryGetL3NodeResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.L3Node = L3Node.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetL3NodeResponse {
    const message = { ...baseQueryGetL3NodeResponse } as QueryGetL3NodeResponse;
    if (object.L3Node !== undefined && object.L3Node !== null) {
      message.L3Node = L3Node.fromJSON(object.L3Node);
    } else {
      message.L3Node = undefined;
    }
    return message;
  },

  toJSON(message: QueryGetL3NodeResponse): unknown {
    const obj: any = {};
    message.L3Node !== undefined &&
      (obj.L3Node = message.L3Node ? L3Node.toJSON(message.L3Node) : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetL3NodeResponse>
  ): QueryGetL3NodeResponse {
    const message = { ...baseQueryGetL3NodeResponse } as QueryGetL3NodeResponse;
    if (object.L3Node !== undefined && object.L3Node !== null) {
      message.L3Node = L3Node.fromPartial(object.L3Node);
    } else {
      message.L3Node = undefined;
    }
    return message;
  },
};

const baseQueryAllL3NodeRequest: object = {};

export const QueryAllL3NodeRequest = {
  encode(
    message: QueryAllL3NodeRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryAllL3NodeRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryAllL3NodeRequest } as QueryAllL3NodeRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllL3NodeRequest {
    const message = { ...baseQueryAllL3NodeRequest } as QueryAllL3NodeRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllL3NodeRequest): unknown {
    const obj: any = {};
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageRequest.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllL3NodeRequest>
  ): QueryAllL3NodeRequest {
    const message = { ...baseQueryAllL3NodeRequest } as QueryAllL3NodeRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryAllL3NodeResponse: object = {};

export const QueryAllL3NodeResponse = {
  encode(
    message: QueryAllL3NodeResponse,
    writer: Writer = Writer.create()
  ): Writer {
    for (const v of message.L3Node) {
      L3Node.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(
        message.pagination,
        writer.uint32(18).fork()
      ).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): QueryAllL3NodeResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseQueryAllL3NodeResponse } as QueryAllL3NodeResponse;
    message.L3Node = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.L3Node.push(L3Node.decode(reader, reader.uint32()));
          break;
        case 2:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllL3NodeResponse {
    const message = { ...baseQueryAllL3NodeResponse } as QueryAllL3NodeResponse;
    message.L3Node = [];
    if (object.L3Node !== undefined && object.L3Node !== null) {
      for (const e of object.L3Node) {
        message.L3Node.push(L3Node.fromJSON(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllL3NodeResponse): unknown {
    const obj: any = {};
    if (message.L3Node) {
      obj.L3Node = message.L3Node.map((e) =>
        e ? L3Node.toJSON(e) : undefined
      );
    } else {
      obj.L3Node = [];
    }
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageResponse.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllL3NodeResponse>
  ): QueryAllL3NodeResponse {
    const message = { ...baseQueryAllL3NodeResponse } as QueryAllL3NodeResponse;
    message.L3Node = [];
    if (object.L3Node !== undefined && object.L3Node !== null) {
      for (const e of object.L3Node) {
        message.L3Node.push(L3Node.fromPartial(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryGetAttachedUserRequest: object = { iidapId: 0, account: 0 };

export const QueryGetAttachedUserRequest = {
  encode(
    message: QueryGetAttachedUserRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.iidapId !== 0) {
      writer.uint32(8).int32(message.iidapId);
    }
    if (message.account !== 0) {
      writer.uint32(16).int32(message.account);
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryGetAttachedUserRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryGetAttachedUserRequest,
    } as QueryGetAttachedUserRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.iidapId = reader.int32();
          break;
        case 2:
          message.account = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetAttachedUserRequest {
    const message = {
      ...baseQueryGetAttachedUserRequest,
    } as QueryGetAttachedUserRequest;
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = Number(object.iidapId);
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = Number(object.account);
    } else {
      message.account = 0;
    }
    return message;
  },

  toJSON(message: QueryGetAttachedUserRequest): unknown {
    const obj: any = {};
    message.iidapId !== undefined && (obj.iidapId = message.iidapId);
    message.account !== undefined && (obj.account = message.account);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetAttachedUserRequest>
  ): QueryGetAttachedUserRequest {
    const message = {
      ...baseQueryGetAttachedUserRequest,
    } as QueryGetAttachedUserRequest;
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = object.iidapId;
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = object.account;
    } else {
      message.account = 0;
    }
    return message;
  },
};

const baseQueryGetAttachedUserResponse: object = {};

export const QueryGetAttachedUserResponse = {
  encode(
    message: QueryGetAttachedUserResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.attachedUser !== undefined) {
      AttachedUser.encode(
        message.attachedUser,
        writer.uint32(10).fork()
      ).ldelim();
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryGetAttachedUserResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryGetAttachedUserResponse,
    } as QueryGetAttachedUserResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.attachedUser = AttachedUser.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetAttachedUserResponse {
    const message = {
      ...baseQueryGetAttachedUserResponse,
    } as QueryGetAttachedUserResponse;
    if (object.attachedUser !== undefined && object.attachedUser !== null) {
      message.attachedUser = AttachedUser.fromJSON(object.attachedUser);
    } else {
      message.attachedUser = undefined;
    }
    return message;
  },

  toJSON(message: QueryGetAttachedUserResponse): unknown {
    const obj: any = {};
    message.attachedUser !== undefined &&
      (obj.attachedUser = message.attachedUser
        ? AttachedUser.toJSON(message.attachedUser)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetAttachedUserResponse>
  ): QueryGetAttachedUserResponse {
    const message = {
      ...baseQueryGetAttachedUserResponse,
    } as QueryGetAttachedUserResponse;
    if (object.attachedUser !== undefined && object.attachedUser !== null) {
      message.attachedUser = AttachedUser.fromPartial(object.attachedUser);
    } else {
      message.attachedUser = undefined;
    }
    return message;
  },
};

const baseQueryAllAttachedUserRequest: object = {};

export const QueryAllAttachedUserRequest = {
  encode(
    message: QueryAllAttachedUserRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryAllAttachedUserRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryAllAttachedUserRequest,
    } as QueryAllAttachedUserRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllAttachedUserRequest {
    const message = {
      ...baseQueryAllAttachedUserRequest,
    } as QueryAllAttachedUserRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllAttachedUserRequest): unknown {
    const obj: any = {};
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageRequest.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllAttachedUserRequest>
  ): QueryAllAttachedUserRequest {
    const message = {
      ...baseQueryAllAttachedUserRequest,
    } as QueryAllAttachedUserRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryAllAttachedUserResponse: object = {};

export const QueryAllAttachedUserResponse = {
  encode(
    message: QueryAllAttachedUserResponse,
    writer: Writer = Writer.create()
  ): Writer {
    for (const v of message.attachedUser) {
      AttachedUser.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(
        message.pagination,
        writer.uint32(18).fork()
      ).ldelim();
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryAllAttachedUserResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryAllAttachedUserResponse,
    } as QueryAllAttachedUserResponse;
    message.attachedUser = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.attachedUser.push(
            AttachedUser.decode(reader, reader.uint32())
          );
          break;
        case 2:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllAttachedUserResponse {
    const message = {
      ...baseQueryAllAttachedUserResponse,
    } as QueryAllAttachedUserResponse;
    message.attachedUser = [];
    if (object.attachedUser !== undefined && object.attachedUser !== null) {
      for (const e of object.attachedUser) {
        message.attachedUser.push(AttachedUser.fromJSON(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllAttachedUserResponse): unknown {
    const obj: any = {};
    if (message.attachedUser) {
      obj.attachedUser = message.attachedUser.map((e) =>
        e ? AttachedUser.toJSON(e) : undefined
      );
    } else {
      obj.attachedUser = [];
    }
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageResponse.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllAttachedUserResponse>
  ): QueryAllAttachedUserResponse {
    const message = {
      ...baseQueryAllAttachedUserResponse,
    } as QueryAllAttachedUserResponse;
    message.attachedUser = [];
    if (object.attachedUser !== undefined && object.attachedUser !== null) {
      for (const e of object.attachedUser) {
        message.attachedUser.push(AttachedUser.fromPartial(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryGetRollupDigestRequest: object = { id: 0 };

export const QueryGetRollupDigestRequest = {
  encode(
    message: QueryGetRollupDigestRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryGetRollupDigestRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryGetRollupDigestRequest,
    } as QueryGetRollupDigestRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetRollupDigestRequest {
    const message = {
      ...baseQueryGetRollupDigestRequest,
    } as QueryGetRollupDigestRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: QueryGetRollupDigestRequest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetRollupDigestRequest>
  ): QueryGetRollupDigestRequest {
    const message = {
      ...baseQueryGetRollupDigestRequest,
    } as QueryGetRollupDigestRequest;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseQueryGetRollupDigestResponse: object = {};

export const QueryGetRollupDigestResponse = {
  encode(
    message: QueryGetRollupDigestResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.RollupDigest !== undefined) {
      RollupDigest.encode(
        message.RollupDigest,
        writer.uint32(10).fork()
      ).ldelim();
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryGetRollupDigestResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryGetRollupDigestResponse,
    } as QueryGetRollupDigestResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.RollupDigest = RollupDigest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryGetRollupDigestResponse {
    const message = {
      ...baseQueryGetRollupDigestResponse,
    } as QueryGetRollupDigestResponse;
    if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
      message.RollupDigest = RollupDigest.fromJSON(object.RollupDigest);
    } else {
      message.RollupDigest = undefined;
    }
    return message;
  },

  toJSON(message: QueryGetRollupDigestResponse): unknown {
    const obj: any = {};
    message.RollupDigest !== undefined &&
      (obj.RollupDigest = message.RollupDigest
        ? RollupDigest.toJSON(message.RollupDigest)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryGetRollupDigestResponse>
  ): QueryGetRollupDigestResponse {
    const message = {
      ...baseQueryGetRollupDigestResponse,
    } as QueryGetRollupDigestResponse;
    if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
      message.RollupDigest = RollupDigest.fromPartial(object.RollupDigest);
    } else {
      message.RollupDigest = undefined;
    }
    return message;
  },
};

const baseQueryAllRollupDigestRequest: object = {};

export const QueryAllRollupDigestRequest = {
  encode(
    message: QueryAllRollupDigestRequest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryAllRollupDigestRequest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryAllRollupDigestRequest,
    } as QueryAllRollupDigestRequest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllRollupDigestRequest {
    const message = {
      ...baseQueryAllRollupDigestRequest,
    } as QueryAllRollupDigestRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllRollupDigestRequest): unknown {
    const obj: any = {};
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageRequest.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllRollupDigestRequest>
  ): QueryAllRollupDigestRequest {
    const message = {
      ...baseQueryAllRollupDigestRequest,
    } as QueryAllRollupDigestRequest;
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageRequest.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

const baseQueryAllRollupDigestResponse: object = {};

export const QueryAllRollupDigestResponse = {
  encode(
    message: QueryAllRollupDigestResponse,
    writer: Writer = Writer.create()
  ): Writer {
    for (const v of message.RollupDigest) {
      RollupDigest.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(
        message.pagination,
        writer.uint32(18).fork()
      ).ldelim();
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): QueryAllRollupDigestResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseQueryAllRollupDigestResponse,
    } as QueryAllRollupDigestResponse;
    message.RollupDigest = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.RollupDigest.push(
            RollupDigest.decode(reader, reader.uint32())
          );
          break;
        case 2:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): QueryAllRollupDigestResponse {
    const message = {
      ...baseQueryAllRollupDigestResponse,
    } as QueryAllRollupDigestResponse;
    message.RollupDigest = [];
    if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
      for (const e of object.RollupDigest) {
        message.RollupDigest.push(RollupDigest.fromJSON(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromJSON(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },

  toJSON(message: QueryAllRollupDigestResponse): unknown {
    const obj: any = {};
    if (message.RollupDigest) {
      obj.RollupDigest = message.RollupDigest.map((e) =>
        e ? RollupDigest.toJSON(e) : undefined
      );
    } else {
      obj.RollupDigest = [];
    }
    message.pagination !== undefined &&
      (obj.pagination = message.pagination
        ? PageResponse.toJSON(message.pagination)
        : undefined);
    return obj;
  },

  fromPartial(
    object: DeepPartial<QueryAllRollupDigestResponse>
  ): QueryAllRollupDigestResponse {
    const message = {
      ...baseQueryAllRollupDigestResponse,
    } as QueryAllRollupDigestResponse;
    message.RollupDigest = [];
    if (object.RollupDigest !== undefined && object.RollupDigest !== null) {
      for (const e of object.RollupDigest) {
        message.RollupDigest.push(RollupDigest.fromPartial(e));
      }
    }
    if (object.pagination !== undefined && object.pagination !== null) {
      message.pagination = PageResponse.fromPartial(object.pagination);
    } else {
      message.pagination = undefined;
    }
    return message;
  },
};

/** Query defines the gRPC querier service. */
export interface Query {
  /** Queries a rollup by id. */
  Rollup(request: QueryGetRollupRequest): Promise<QueryGetRollupResponse>;
  /** Queries a list of rollup items. */
  RollupAll(request: QueryAllRollupRequest): Promise<QueryAllRollupResponse>;
  /** Queries a message by id. */
  Message(request: QueryGetMessageRequest): Promise<QueryGetMessageResponse>;
  /** Queries a list of message items. */
  MessageAll(request: QueryAllMessageRequest): Promise<QueryAllMessageResponse>;
  /** Queries a l3Node by id. */
  L3Node(request: QueryGetL3NodeRequest): Promise<QueryGetL3NodeResponse>;
  /** Queries a list of l3Node items. */
  L3NodeAll(request: QueryAllL3NodeRequest): Promise<QueryAllL3NodeResponse>;
  /** Queries a attachedUser by index. */
  AttachedUser(
    request: QueryGetAttachedUserRequest
  ): Promise<QueryGetAttachedUserResponse>;
  /** Queries a list of attachedUser items. */
  AttachedUserAll(
    request: QueryAllAttachedUserRequest
  ): Promise<QueryAllAttachedUserResponse>;
  /** Queries a rollupDigest by id. */
  RollupDigest(
    request: QueryGetRollupDigestRequest
  ): Promise<QueryGetRollupDigestResponse>;
  /** Queries a list of rollupDigest items. */
  RollupDigestAll(
    request: QueryAllRollupDigestRequest
  ): Promise<QueryAllRollupDigestResponse>;
}

export class QueryClientImpl implements Query {
  private readonly rpc: Rpc;
  constructor(rpc: Rpc) {
    this.rpc = rpc;
  }
  Rollup(request: QueryGetRollupRequest): Promise<QueryGetRollupResponse> {
    const data = QueryGetRollupRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "Rollup",
      data
    );
    return promise.then((data) =>
      QueryGetRollupResponse.decode(new Reader(data))
    );
  }

  RollupAll(request: QueryAllRollupRequest): Promise<QueryAllRollupResponse> {
    const data = QueryAllRollupRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "RollupAll",
      data
    );
    return promise.then((data) =>
      QueryAllRollupResponse.decode(new Reader(data))
    );
  }

  Message(request: QueryGetMessageRequest): Promise<QueryGetMessageResponse> {
    const data = QueryGetMessageRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "Message",
      data
    );
    return promise.then((data) =>
      QueryGetMessageResponse.decode(new Reader(data))
    );
  }

  MessageAll(
    request: QueryAllMessageRequest
  ): Promise<QueryAllMessageResponse> {
    const data = QueryAllMessageRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "MessageAll",
      data
    );
    return promise.then((data) =>
      QueryAllMessageResponse.decode(new Reader(data))
    );
  }

  L3Node(request: QueryGetL3NodeRequest): Promise<QueryGetL3NodeResponse> {
    const data = QueryGetL3NodeRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "L3Node",
      data
    );
    return promise.then((data) =>
      QueryGetL3NodeResponse.decode(new Reader(data))
    );
  }

  L3NodeAll(request: QueryAllL3NodeRequest): Promise<QueryAllL3NodeResponse> {
    const data = QueryAllL3NodeRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "L3NodeAll",
      data
    );
    return promise.then((data) =>
      QueryAllL3NodeResponse.decode(new Reader(data))
    );
  }

  AttachedUser(
    request: QueryGetAttachedUserRequest
  ): Promise<QueryGetAttachedUserResponse> {
    const data = QueryGetAttachedUserRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "AttachedUser",
      data
    );
    return promise.then((data) =>
      QueryGetAttachedUserResponse.decode(new Reader(data))
    );
  }

  AttachedUserAll(
    request: QueryAllAttachedUserRequest
  ): Promise<QueryAllAttachedUserResponse> {
    const data = QueryAllAttachedUserRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "AttachedUserAll",
      data
    );
    return promise.then((data) =>
      QueryAllAttachedUserResponse.decode(new Reader(data))
    );
  }

  RollupDigest(
    request: QueryGetRollupDigestRequest
  ): Promise<QueryGetRollupDigestResponse> {
    const data = QueryGetRollupDigestRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "RollupDigest",
      data
    );
    return promise.then((data) =>
      QueryGetRollupDigestResponse.decode(new Reader(data))
    );
  }

  RollupDigestAll(
    request: QueryAllRollupDigestRequest
  ): Promise<QueryAllRollupDigestResponse> {
    const data = QueryAllRollupDigestRequest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Query",
      "RollupDigestAll",
      data
    );
    return promise.then((data) =>
      QueryAllRollupDigestResponse.decode(new Reader(data))
    );
  }
}

interface Rpc {
  request(
    service: string,
    method: string,
    data: Uint8Array
  ): Promise<Uint8Array>;
}

declare var self: any | undefined;
declare var window: any | undefined;
var globalThis: any = (() => {
  if (typeof globalThis !== "undefined") return globalThis;
  if (typeof self !== "undefined") return self;
  if (typeof window !== "undefined") return window;
  if (typeof global !== "undefined") return global;
  throw "Unable to locate global object";
})();

type Builtin = Date | Function | Uint8Array | string | number | undefined;
export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function longToNumber(long: Long): number {
  if (long.gt(Number.MAX_SAFE_INTEGER)) {
    throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
  }
  return long.toNumber();
}

if (util.Long !== Long) {
  util.Long = Long as any;
  configure();
}
