/* eslint-disable */
import * as Long from "long";
import { util, configure, Writer, Reader } from "protobufjs/minimal";

export const protobufPackage = "cosmonaut.voter.voter";

export interface RollupDigest {
  id: number;
  dsUri: string;
  currentHash: string;
  status: string;
  creator: string;
}

const baseRollupDigest: object = {
  id: 0,
  dsUri: "",
  currentHash: "",
  status: "",
  creator: "",
};

export const RollupDigest = {
  encode(message: RollupDigest, writer: Writer = Writer.create()): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.dsUri !== "") {
      writer.uint32(18).string(message.dsUri);
    }
    if (message.currentHash !== "") {
      writer.uint32(26).string(message.currentHash);
    }
    if (message.status !== "") {
      writer.uint32(34).string(message.status);
    }
    if (message.creator !== "") {
      writer.uint32(42).string(message.creator);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): RollupDigest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseRollupDigest } as RollupDigest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        case 2:
          message.dsUri = reader.string();
          break;
        case 3:
          message.currentHash = reader.string();
          break;
        case 4:
          message.status = reader.string();
          break;
        case 5:
          message.creator = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): RollupDigest {
    const message = { ...baseRollupDigest } as RollupDigest;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = String(object.dsUri);
    } else {
      message.dsUri = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = String(object.currentHash);
    } else {
      message.currentHash = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = String(object.status);
    } else {
      message.status = "";
    }
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    return message;
  },

  toJSON(message: RollupDigest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    message.dsUri !== undefined && (obj.dsUri = message.dsUri);
    message.currentHash !== undefined &&
      (obj.currentHash = message.currentHash);
    message.status !== undefined && (obj.status = message.status);
    message.creator !== undefined && (obj.creator = message.creator);
    return obj;
  },

  fromPartial(object: DeepPartial<RollupDigest>): RollupDigest {
    const message = { ...baseRollupDigest } as RollupDigest;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = object.dsUri;
    } else {
      message.dsUri = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = object.currentHash;
    } else {
      message.currentHash = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = object.status;
    } else {
      message.status = "";
    }
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    return message;
  },
};

declare var self: any | undefined;
declare var window: any | undefined;
var globalThis: any = (() => {
  if (typeof globalThis !== "undefined") return globalThis;
  if (typeof self !== "undefined") return self;
  if (typeof window !== "undefined") return window;
  if (typeof global !== "undefined") return global;
  throw "Unable to locate global object";
})();

type Builtin = Date | Function | Uint8Array | string | number | undefined;
export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function longToNumber(long: Long): number {
  if (long.gt(Number.MAX_SAFE_INTEGER)) {
    throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
  }
  return long.toNumber();
}

if (util.Long !== Long) {
  util.Long = Long as any;
  configure();
}
