import { Reader, Writer } from "protobufjs/minimal";
export declare const protobufPackage = "cosmonaut.voter.voter";
export interface MsgCreateRollup {
    creator: string;
    prevHash: string;
    currentHash: string;
    dsUri: string;
    inbox: string[];
}
export interface MsgCreateRollupResponse {
    id: number;
}
export interface MsgUpdateRollup {
    creator: string;
    id: number;
    prevHash: string;
    currentHash: string;
    dsUri: string;
    inbox: string[];
}
export interface MsgUpdateRollupResponse {
}
export interface MsgDeleteRollup {
    creator: string;
    id: number;
}
export interface MsgDeleteRollupResponse {
}
export interface MsgCreateMessage {
    creator: string;
    status: string;
    name: string;
    data: string[];
}
export interface MsgCreateMessageResponse {
    id: number;
}
export interface MsgUpdateMessage {
    creator: string;
    id: number;
    status: string;
    name: string;
    data: string[];
}
export interface MsgUpdateMessageResponse {
}
export interface MsgDeleteMessage {
    creator: string;
    id: number;
}
export interface MsgDeleteMessageResponse {
}
export interface MsgCreateL3Node {
    creator: string;
    publicKey: string;
    options: string[];
}
export interface MsgCreateL3NodeResponse {
    id: number;
}
export interface MsgUpdateL3Node {
    creator: string;
    id: number;
    publicKey: string;
    options: string[];
}
export interface MsgUpdateL3NodeResponse {
}
export interface MsgDeleteL3Node {
    creator: string;
    id: number;
}
export interface MsgDeleteL3NodeResponse {
}
export interface MsgCreateAttachedUser {
    creator: string;
    iidapId: number;
    account: number;
    userName: string;
}
export interface MsgCreateAttachedUserResponse {
}
export interface MsgUpdateAttachedUser {
    creator: string;
    iidapId: number;
    account: number;
    userName: string;
}
export interface MsgUpdateAttachedUserResponse {
}
export interface MsgDeleteAttachedUser {
    creator: string;
    iidapId: number;
    account: number;
}
export interface MsgDeleteAttachedUserResponse {
}
export interface MsgCreateRollupDigest {
    creator: string;
    dsUri: string;
    currentHash: string;
    status: string;
}
export interface MsgCreateRollupDigestResponse {
    id: number;
}
export interface MsgUpdateRollupDigest {
    creator: string;
    id: number;
    dsUri: string;
    currentHash: string;
    status: string;
}
export interface MsgUpdateRollupDigestResponse {
}
export interface MsgDeleteRollupDigest {
    creator: string;
    id: number;
}
export interface MsgDeleteRollupDigestResponse {
}
export declare const MsgCreateRollup: {
    encode(message: MsgCreateRollup, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateRollup;
    fromJSON(object: any): MsgCreateRollup;
    toJSON(message: MsgCreateRollup): unknown;
    fromPartial(object: DeepPartial<MsgCreateRollup>): MsgCreateRollup;
};
export declare const MsgCreateRollupResponse: {
    encode(message: MsgCreateRollupResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateRollupResponse;
    fromJSON(object: any): MsgCreateRollupResponse;
    toJSON(message: MsgCreateRollupResponse): unknown;
    fromPartial(object: DeepPartial<MsgCreateRollupResponse>): MsgCreateRollupResponse;
};
export declare const MsgUpdateRollup: {
    encode(message: MsgUpdateRollup, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateRollup;
    fromJSON(object: any): MsgUpdateRollup;
    toJSON(message: MsgUpdateRollup): unknown;
    fromPartial(object: DeepPartial<MsgUpdateRollup>): MsgUpdateRollup;
};
export declare const MsgUpdateRollupResponse: {
    encode(_: MsgUpdateRollupResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateRollupResponse;
    fromJSON(_: any): MsgUpdateRollupResponse;
    toJSON(_: MsgUpdateRollupResponse): unknown;
    fromPartial(_: DeepPartial<MsgUpdateRollupResponse>): MsgUpdateRollupResponse;
};
export declare const MsgDeleteRollup: {
    encode(message: MsgDeleteRollup, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteRollup;
    fromJSON(object: any): MsgDeleteRollup;
    toJSON(message: MsgDeleteRollup): unknown;
    fromPartial(object: DeepPartial<MsgDeleteRollup>): MsgDeleteRollup;
};
export declare const MsgDeleteRollupResponse: {
    encode(_: MsgDeleteRollupResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteRollupResponse;
    fromJSON(_: any): MsgDeleteRollupResponse;
    toJSON(_: MsgDeleteRollupResponse): unknown;
    fromPartial(_: DeepPartial<MsgDeleteRollupResponse>): MsgDeleteRollupResponse;
};
export declare const MsgCreateMessage: {
    encode(message: MsgCreateMessage, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateMessage;
    fromJSON(object: any): MsgCreateMessage;
    toJSON(message: MsgCreateMessage): unknown;
    fromPartial(object: DeepPartial<MsgCreateMessage>): MsgCreateMessage;
};
export declare const MsgCreateMessageResponse: {
    encode(message: MsgCreateMessageResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateMessageResponse;
    fromJSON(object: any): MsgCreateMessageResponse;
    toJSON(message: MsgCreateMessageResponse): unknown;
    fromPartial(object: DeepPartial<MsgCreateMessageResponse>): MsgCreateMessageResponse;
};
export declare const MsgUpdateMessage: {
    encode(message: MsgUpdateMessage, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateMessage;
    fromJSON(object: any): MsgUpdateMessage;
    toJSON(message: MsgUpdateMessage): unknown;
    fromPartial(object: DeepPartial<MsgUpdateMessage>): MsgUpdateMessage;
};
export declare const MsgUpdateMessageResponse: {
    encode(_: MsgUpdateMessageResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateMessageResponse;
    fromJSON(_: any): MsgUpdateMessageResponse;
    toJSON(_: MsgUpdateMessageResponse): unknown;
    fromPartial(_: DeepPartial<MsgUpdateMessageResponse>): MsgUpdateMessageResponse;
};
export declare const MsgDeleteMessage: {
    encode(message: MsgDeleteMessage, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteMessage;
    fromJSON(object: any): MsgDeleteMessage;
    toJSON(message: MsgDeleteMessage): unknown;
    fromPartial(object: DeepPartial<MsgDeleteMessage>): MsgDeleteMessage;
};
export declare const MsgDeleteMessageResponse: {
    encode(_: MsgDeleteMessageResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteMessageResponse;
    fromJSON(_: any): MsgDeleteMessageResponse;
    toJSON(_: MsgDeleteMessageResponse): unknown;
    fromPartial(_: DeepPartial<MsgDeleteMessageResponse>): MsgDeleteMessageResponse;
};
export declare const MsgCreateL3Node: {
    encode(message: MsgCreateL3Node, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateL3Node;
    fromJSON(object: any): MsgCreateL3Node;
    toJSON(message: MsgCreateL3Node): unknown;
    fromPartial(object: DeepPartial<MsgCreateL3Node>): MsgCreateL3Node;
};
export declare const MsgCreateL3NodeResponse: {
    encode(message: MsgCreateL3NodeResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateL3NodeResponse;
    fromJSON(object: any): MsgCreateL3NodeResponse;
    toJSON(message: MsgCreateL3NodeResponse): unknown;
    fromPartial(object: DeepPartial<MsgCreateL3NodeResponse>): MsgCreateL3NodeResponse;
};
export declare const MsgUpdateL3Node: {
    encode(message: MsgUpdateL3Node, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateL3Node;
    fromJSON(object: any): MsgUpdateL3Node;
    toJSON(message: MsgUpdateL3Node): unknown;
    fromPartial(object: DeepPartial<MsgUpdateL3Node>): MsgUpdateL3Node;
};
export declare const MsgUpdateL3NodeResponse: {
    encode(_: MsgUpdateL3NodeResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateL3NodeResponse;
    fromJSON(_: any): MsgUpdateL3NodeResponse;
    toJSON(_: MsgUpdateL3NodeResponse): unknown;
    fromPartial(_: DeepPartial<MsgUpdateL3NodeResponse>): MsgUpdateL3NodeResponse;
};
export declare const MsgDeleteL3Node: {
    encode(message: MsgDeleteL3Node, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteL3Node;
    fromJSON(object: any): MsgDeleteL3Node;
    toJSON(message: MsgDeleteL3Node): unknown;
    fromPartial(object: DeepPartial<MsgDeleteL3Node>): MsgDeleteL3Node;
};
export declare const MsgDeleteL3NodeResponse: {
    encode(_: MsgDeleteL3NodeResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteL3NodeResponse;
    fromJSON(_: any): MsgDeleteL3NodeResponse;
    toJSON(_: MsgDeleteL3NodeResponse): unknown;
    fromPartial(_: DeepPartial<MsgDeleteL3NodeResponse>): MsgDeleteL3NodeResponse;
};
export declare const MsgCreateAttachedUser: {
    encode(message: MsgCreateAttachedUser, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateAttachedUser;
    fromJSON(object: any): MsgCreateAttachedUser;
    toJSON(message: MsgCreateAttachedUser): unknown;
    fromPartial(object: DeepPartial<MsgCreateAttachedUser>): MsgCreateAttachedUser;
};
export declare const MsgCreateAttachedUserResponse: {
    encode(_: MsgCreateAttachedUserResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateAttachedUserResponse;
    fromJSON(_: any): MsgCreateAttachedUserResponse;
    toJSON(_: MsgCreateAttachedUserResponse): unknown;
    fromPartial(_: DeepPartial<MsgCreateAttachedUserResponse>): MsgCreateAttachedUserResponse;
};
export declare const MsgUpdateAttachedUser: {
    encode(message: MsgUpdateAttachedUser, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateAttachedUser;
    fromJSON(object: any): MsgUpdateAttachedUser;
    toJSON(message: MsgUpdateAttachedUser): unknown;
    fromPartial(object: DeepPartial<MsgUpdateAttachedUser>): MsgUpdateAttachedUser;
};
export declare const MsgUpdateAttachedUserResponse: {
    encode(_: MsgUpdateAttachedUserResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateAttachedUserResponse;
    fromJSON(_: any): MsgUpdateAttachedUserResponse;
    toJSON(_: MsgUpdateAttachedUserResponse): unknown;
    fromPartial(_: DeepPartial<MsgUpdateAttachedUserResponse>): MsgUpdateAttachedUserResponse;
};
export declare const MsgDeleteAttachedUser: {
    encode(message: MsgDeleteAttachedUser, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteAttachedUser;
    fromJSON(object: any): MsgDeleteAttachedUser;
    toJSON(message: MsgDeleteAttachedUser): unknown;
    fromPartial(object: DeepPartial<MsgDeleteAttachedUser>): MsgDeleteAttachedUser;
};
export declare const MsgDeleteAttachedUserResponse: {
    encode(_: MsgDeleteAttachedUserResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteAttachedUserResponse;
    fromJSON(_: any): MsgDeleteAttachedUserResponse;
    toJSON(_: MsgDeleteAttachedUserResponse): unknown;
    fromPartial(_: DeepPartial<MsgDeleteAttachedUserResponse>): MsgDeleteAttachedUserResponse;
};
export declare const MsgCreateRollupDigest: {
    encode(message: MsgCreateRollupDigest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateRollupDigest;
    fromJSON(object: any): MsgCreateRollupDigest;
    toJSON(message: MsgCreateRollupDigest): unknown;
    fromPartial(object: DeepPartial<MsgCreateRollupDigest>): MsgCreateRollupDigest;
};
export declare const MsgCreateRollupDigestResponse: {
    encode(message: MsgCreateRollupDigestResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgCreateRollupDigestResponse;
    fromJSON(object: any): MsgCreateRollupDigestResponse;
    toJSON(message: MsgCreateRollupDigestResponse): unknown;
    fromPartial(object: DeepPartial<MsgCreateRollupDigestResponse>): MsgCreateRollupDigestResponse;
};
export declare const MsgUpdateRollupDigest: {
    encode(message: MsgUpdateRollupDigest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateRollupDigest;
    fromJSON(object: any): MsgUpdateRollupDigest;
    toJSON(message: MsgUpdateRollupDigest): unknown;
    fromPartial(object: DeepPartial<MsgUpdateRollupDigest>): MsgUpdateRollupDigest;
};
export declare const MsgUpdateRollupDigestResponse: {
    encode(_: MsgUpdateRollupDigestResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgUpdateRollupDigestResponse;
    fromJSON(_: any): MsgUpdateRollupDigestResponse;
    toJSON(_: MsgUpdateRollupDigestResponse): unknown;
    fromPartial(_: DeepPartial<MsgUpdateRollupDigestResponse>): MsgUpdateRollupDigestResponse;
};
export declare const MsgDeleteRollupDigest: {
    encode(message: MsgDeleteRollupDigest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteRollupDigest;
    fromJSON(object: any): MsgDeleteRollupDigest;
    toJSON(message: MsgDeleteRollupDigest): unknown;
    fromPartial(object: DeepPartial<MsgDeleteRollupDigest>): MsgDeleteRollupDigest;
};
export declare const MsgDeleteRollupDigestResponse: {
    encode(_: MsgDeleteRollupDigestResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): MsgDeleteRollupDigestResponse;
    fromJSON(_: any): MsgDeleteRollupDigestResponse;
    toJSON(_: MsgDeleteRollupDigestResponse): unknown;
    fromPartial(_: DeepPartial<MsgDeleteRollupDigestResponse>): MsgDeleteRollupDigestResponse;
};
/** Msg defines the Msg service. */
export interface Msg {
    CreateRollup(request: MsgCreateRollup): Promise<MsgCreateRollupResponse>;
    UpdateRollup(request: MsgUpdateRollup): Promise<MsgUpdateRollupResponse>;
    DeleteRollup(request: MsgDeleteRollup): Promise<MsgDeleteRollupResponse>;
    CreateMessage(request: MsgCreateMessage): Promise<MsgCreateMessageResponse>;
    UpdateMessage(request: MsgUpdateMessage): Promise<MsgUpdateMessageResponse>;
    DeleteMessage(request: MsgDeleteMessage): Promise<MsgDeleteMessageResponse>;
    CreateL3Node(request: MsgCreateL3Node): Promise<MsgCreateL3NodeResponse>;
    UpdateL3Node(request: MsgUpdateL3Node): Promise<MsgUpdateL3NodeResponse>;
    DeleteL3Node(request: MsgDeleteL3Node): Promise<MsgDeleteL3NodeResponse>;
    CreateAttachedUser(request: MsgCreateAttachedUser): Promise<MsgCreateAttachedUserResponse>;
    UpdateAttachedUser(request: MsgUpdateAttachedUser): Promise<MsgUpdateAttachedUserResponse>;
    DeleteAttachedUser(request: MsgDeleteAttachedUser): Promise<MsgDeleteAttachedUserResponse>;
    CreateRollupDigest(request: MsgCreateRollupDigest): Promise<MsgCreateRollupDigestResponse>;
    UpdateRollupDigest(request: MsgUpdateRollupDigest): Promise<MsgUpdateRollupDigestResponse>;
    /** this line is used by starport scaffolding # proto/tx/rpc */
    DeleteRollupDigest(request: MsgDeleteRollupDigest): Promise<MsgDeleteRollupDigestResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: Rpc);
    CreateRollup(request: MsgCreateRollup): Promise<MsgCreateRollupResponse>;
    UpdateRollup(request: MsgUpdateRollup): Promise<MsgUpdateRollupResponse>;
    DeleteRollup(request: MsgDeleteRollup): Promise<MsgDeleteRollupResponse>;
    CreateMessage(request: MsgCreateMessage): Promise<MsgCreateMessageResponse>;
    UpdateMessage(request: MsgUpdateMessage): Promise<MsgUpdateMessageResponse>;
    DeleteMessage(request: MsgDeleteMessage): Promise<MsgDeleteMessageResponse>;
    CreateL3Node(request: MsgCreateL3Node): Promise<MsgCreateL3NodeResponse>;
    UpdateL3Node(request: MsgUpdateL3Node): Promise<MsgUpdateL3NodeResponse>;
    DeleteL3Node(request: MsgDeleteL3Node): Promise<MsgDeleteL3NodeResponse>;
    CreateAttachedUser(request: MsgCreateAttachedUser): Promise<MsgCreateAttachedUserResponse>;
    UpdateAttachedUser(request: MsgUpdateAttachedUser): Promise<MsgUpdateAttachedUserResponse>;
    DeleteAttachedUser(request: MsgDeleteAttachedUser): Promise<MsgDeleteAttachedUserResponse>;
    CreateRollupDigest(request: MsgCreateRollupDigest): Promise<MsgCreateRollupDigestResponse>;
    UpdateRollupDigest(request: MsgUpdateRollupDigest): Promise<MsgUpdateRollupDigestResponse>;
    DeleteRollupDigest(request: MsgDeleteRollupDigest): Promise<MsgDeleteRollupDigestResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
declare type Builtin = Date | Function | Uint8Array | string | number | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
