/* eslint-disable */
import { Reader, util, configure, Writer } from "protobufjs/minimal";
import * as Long from "long";

export const protobufPackage = "cosmonaut.voter.voter";

export interface MsgCreateRollup {
  creator: string;
  prevHash: string;
  currentHash: string;
  dsUri: string;
  inbox: string[];
}

export interface MsgCreateRollupResponse {
  id: number;
}

export interface MsgUpdateRollup {
  creator: string;
  id: number;
  prevHash: string;
  currentHash: string;
  dsUri: string;
  inbox: string[];
}

export interface MsgUpdateRollupResponse {}

export interface MsgDeleteRollup {
  creator: string;
  id: number;
}

export interface MsgDeleteRollupResponse {}

export interface MsgCreateMessage {
  creator: string;
  status: string;
  name: string;
  data: string[];
}

export interface MsgCreateMessageResponse {
  id: number;
}

export interface MsgUpdateMessage {
  creator: string;
  id: number;
  status: string;
  name: string;
  data: string[];
}

export interface MsgUpdateMessageResponse {}

export interface MsgDeleteMessage {
  creator: string;
  id: number;
}

export interface MsgDeleteMessageResponse {}

export interface MsgCreateL3Node {
  creator: string;
  publicKey: string;
  options: string[];
}

export interface MsgCreateL3NodeResponse {
  id: number;
}

export interface MsgUpdateL3Node {
  creator: string;
  id: number;
  publicKey: string;
  options: string[];
}

export interface MsgUpdateL3NodeResponse {}

export interface MsgDeleteL3Node {
  creator: string;
  id: number;
}

export interface MsgDeleteL3NodeResponse {}

export interface MsgCreateAttachedUser {
  creator: string;
  iidapId: number;
  account: number;
  userName: string;
}

export interface MsgCreateAttachedUserResponse {}

export interface MsgUpdateAttachedUser {
  creator: string;
  iidapId: number;
  account: number;
  userName: string;
}

export interface MsgUpdateAttachedUserResponse {}

export interface MsgDeleteAttachedUser {
  creator: string;
  iidapId: number;
  account: number;
}

export interface MsgDeleteAttachedUserResponse {}

export interface MsgCreateRollupDigest {
  creator: string;
  dsUri: string;
  currentHash: string;
  status: string;
}

export interface MsgCreateRollupDigestResponse {
  id: number;
}

export interface MsgUpdateRollupDigest {
  creator: string;
  id: number;
  dsUri: string;
  currentHash: string;
  status: string;
}

export interface MsgUpdateRollupDigestResponse {}

export interface MsgDeleteRollupDigest {
  creator: string;
  id: number;
}

export interface MsgDeleteRollupDigestResponse {}

const baseMsgCreateRollup: object = {
  creator: "",
  prevHash: "",
  currentHash: "",
  dsUri: "",
  inbox: "",
};

export const MsgCreateRollup = {
  encode(message: MsgCreateRollup, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.prevHash !== "") {
      writer.uint32(18).string(message.prevHash);
    }
    if (message.currentHash !== "") {
      writer.uint32(26).string(message.currentHash);
    }
    if (message.dsUri !== "") {
      writer.uint32(34).string(message.dsUri);
    }
    for (const v of message.inbox) {
      writer.uint32(42).string(v!);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgCreateRollup {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgCreateRollup } as MsgCreateRollup;
    message.inbox = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.prevHash = reader.string();
          break;
        case 3:
          message.currentHash = reader.string();
          break;
        case 4:
          message.dsUri = reader.string();
          break;
        case 5:
          message.inbox.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateRollup {
    const message = { ...baseMsgCreateRollup } as MsgCreateRollup;
    message.inbox = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.prevHash !== undefined && object.prevHash !== null) {
      message.prevHash = String(object.prevHash);
    } else {
      message.prevHash = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = String(object.currentHash);
    } else {
      message.currentHash = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = String(object.dsUri);
    } else {
      message.dsUri = "";
    }
    if (object.inbox !== undefined && object.inbox !== null) {
      for (const e of object.inbox) {
        message.inbox.push(String(e));
      }
    }
    return message;
  },

  toJSON(message: MsgCreateRollup): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.prevHash !== undefined && (obj.prevHash = message.prevHash);
    message.currentHash !== undefined &&
      (obj.currentHash = message.currentHash);
    message.dsUri !== undefined && (obj.dsUri = message.dsUri);
    if (message.inbox) {
      obj.inbox = message.inbox.map((e) => e);
    } else {
      obj.inbox = [];
    }
    return obj;
  },

  fromPartial(object: DeepPartial<MsgCreateRollup>): MsgCreateRollup {
    const message = { ...baseMsgCreateRollup } as MsgCreateRollup;
    message.inbox = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.prevHash !== undefined && object.prevHash !== null) {
      message.prevHash = object.prevHash;
    } else {
      message.prevHash = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = object.currentHash;
    } else {
      message.currentHash = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = object.dsUri;
    } else {
      message.dsUri = "";
    }
    if (object.inbox !== undefined && object.inbox !== null) {
      for (const e of object.inbox) {
        message.inbox.push(e);
      }
    }
    return message;
  },
};

const baseMsgCreateRollupResponse: object = { id: 0 };

export const MsgCreateRollupResponse = {
  encode(
    message: MsgCreateRollupResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgCreateRollupResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgCreateRollupResponse,
    } as MsgCreateRollupResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateRollupResponse {
    const message = {
      ...baseMsgCreateRollupResponse,
    } as MsgCreateRollupResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgCreateRollupResponse): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgCreateRollupResponse>
  ): MsgCreateRollupResponse {
    const message = {
      ...baseMsgCreateRollupResponse,
    } as MsgCreateRollupResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgUpdateRollup: object = {
  creator: "",
  id: 0,
  prevHash: "",
  currentHash: "",
  dsUri: "",
  inbox: "",
};

export const MsgUpdateRollup = {
  encode(message: MsgUpdateRollup, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    if (message.prevHash !== "") {
      writer.uint32(26).string(message.prevHash);
    }
    if (message.currentHash !== "") {
      writer.uint32(34).string(message.currentHash);
    }
    if (message.dsUri !== "") {
      writer.uint32(42).string(message.dsUri);
    }
    for (const v of message.inbox) {
      writer.uint32(50).string(v!);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgUpdateRollup {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgUpdateRollup } as MsgUpdateRollup;
    message.inbox = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        case 3:
          message.prevHash = reader.string();
          break;
        case 4:
          message.currentHash = reader.string();
          break;
        case 5:
          message.dsUri = reader.string();
          break;
        case 6:
          message.inbox.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgUpdateRollup {
    const message = { ...baseMsgUpdateRollup } as MsgUpdateRollup;
    message.inbox = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    if (object.prevHash !== undefined && object.prevHash !== null) {
      message.prevHash = String(object.prevHash);
    } else {
      message.prevHash = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = String(object.currentHash);
    } else {
      message.currentHash = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = String(object.dsUri);
    } else {
      message.dsUri = "";
    }
    if (object.inbox !== undefined && object.inbox !== null) {
      for (const e of object.inbox) {
        message.inbox.push(String(e));
      }
    }
    return message;
  },

  toJSON(message: MsgUpdateRollup): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    message.prevHash !== undefined && (obj.prevHash = message.prevHash);
    message.currentHash !== undefined &&
      (obj.currentHash = message.currentHash);
    message.dsUri !== undefined && (obj.dsUri = message.dsUri);
    if (message.inbox) {
      obj.inbox = message.inbox.map((e) => e);
    } else {
      obj.inbox = [];
    }
    return obj;
  },

  fromPartial(object: DeepPartial<MsgUpdateRollup>): MsgUpdateRollup {
    const message = { ...baseMsgUpdateRollup } as MsgUpdateRollup;
    message.inbox = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    if (object.prevHash !== undefined && object.prevHash !== null) {
      message.prevHash = object.prevHash;
    } else {
      message.prevHash = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = object.currentHash;
    } else {
      message.currentHash = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = object.dsUri;
    } else {
      message.dsUri = "";
    }
    if (object.inbox !== undefined && object.inbox !== null) {
      for (const e of object.inbox) {
        message.inbox.push(e);
      }
    }
    return message;
  },
};

const baseMsgUpdateRollupResponse: object = {};

export const MsgUpdateRollupResponse = {
  encode(_: MsgUpdateRollupResponse, writer: Writer = Writer.create()): Writer {
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgUpdateRollupResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgUpdateRollupResponse,
    } as MsgUpdateRollupResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgUpdateRollupResponse {
    const message = {
      ...baseMsgUpdateRollupResponse,
    } as MsgUpdateRollupResponse;
    return message;
  },

  toJSON(_: MsgUpdateRollupResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgUpdateRollupResponse>
  ): MsgUpdateRollupResponse {
    const message = {
      ...baseMsgUpdateRollupResponse,
    } as MsgUpdateRollupResponse;
    return message;
  },
};

const baseMsgDeleteRollup: object = { creator: "", id: 0 };

export const MsgDeleteRollup = {
  encode(message: MsgDeleteRollup, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgDeleteRollup {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgDeleteRollup } as MsgDeleteRollup;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgDeleteRollup {
    const message = { ...baseMsgDeleteRollup } as MsgDeleteRollup;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgDeleteRollup): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(object: DeepPartial<MsgDeleteRollup>): MsgDeleteRollup {
    const message = { ...baseMsgDeleteRollup } as MsgDeleteRollup;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgDeleteRollupResponse: object = {};

export const MsgDeleteRollupResponse = {
  encode(_: MsgDeleteRollupResponse, writer: Writer = Writer.create()): Writer {
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgDeleteRollupResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgDeleteRollupResponse,
    } as MsgDeleteRollupResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgDeleteRollupResponse {
    const message = {
      ...baseMsgDeleteRollupResponse,
    } as MsgDeleteRollupResponse;
    return message;
  },

  toJSON(_: MsgDeleteRollupResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgDeleteRollupResponse>
  ): MsgDeleteRollupResponse {
    const message = {
      ...baseMsgDeleteRollupResponse,
    } as MsgDeleteRollupResponse;
    return message;
  },
};

const baseMsgCreateMessage: object = {
  creator: "",
  status: "",
  name: "",
  data: "",
};

export const MsgCreateMessage = {
  encode(message: MsgCreateMessage, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.status !== "") {
      writer.uint32(18).string(message.status);
    }
    if (message.name !== "") {
      writer.uint32(26).string(message.name);
    }
    for (const v of message.data) {
      writer.uint32(34).string(v!);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgCreateMessage {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgCreateMessage } as MsgCreateMessage;
    message.data = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.status = reader.string();
          break;
        case 3:
          message.name = reader.string();
          break;
        case 4:
          message.data.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateMessage {
    const message = { ...baseMsgCreateMessage } as MsgCreateMessage;
    message.data = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = String(object.status);
    } else {
      message.status = "";
    }
    if (object.name !== undefined && object.name !== null) {
      message.name = String(object.name);
    } else {
      message.name = "";
    }
    if (object.data !== undefined && object.data !== null) {
      for (const e of object.data) {
        message.data.push(String(e));
      }
    }
    return message;
  },

  toJSON(message: MsgCreateMessage): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.status !== undefined && (obj.status = message.status);
    message.name !== undefined && (obj.name = message.name);
    if (message.data) {
      obj.data = message.data.map((e) => e);
    } else {
      obj.data = [];
    }
    return obj;
  },

  fromPartial(object: DeepPartial<MsgCreateMessage>): MsgCreateMessage {
    const message = { ...baseMsgCreateMessage } as MsgCreateMessage;
    message.data = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = object.status;
    } else {
      message.status = "";
    }
    if (object.name !== undefined && object.name !== null) {
      message.name = object.name;
    } else {
      message.name = "";
    }
    if (object.data !== undefined && object.data !== null) {
      for (const e of object.data) {
        message.data.push(e);
      }
    }
    return message;
  },
};

const baseMsgCreateMessageResponse: object = { id: 0 };

export const MsgCreateMessageResponse = {
  encode(
    message: MsgCreateMessageResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgCreateMessageResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgCreateMessageResponse,
    } as MsgCreateMessageResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateMessageResponse {
    const message = {
      ...baseMsgCreateMessageResponse,
    } as MsgCreateMessageResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgCreateMessageResponse): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgCreateMessageResponse>
  ): MsgCreateMessageResponse {
    const message = {
      ...baseMsgCreateMessageResponse,
    } as MsgCreateMessageResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgUpdateMessage: object = {
  creator: "",
  id: 0,
  status: "",
  name: "",
  data: "",
};

export const MsgUpdateMessage = {
  encode(message: MsgUpdateMessage, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    if (message.status !== "") {
      writer.uint32(26).string(message.status);
    }
    if (message.name !== "") {
      writer.uint32(34).string(message.name);
    }
    for (const v of message.data) {
      writer.uint32(42).string(v!);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgUpdateMessage {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgUpdateMessage } as MsgUpdateMessage;
    message.data = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        case 3:
          message.status = reader.string();
          break;
        case 4:
          message.name = reader.string();
          break;
        case 5:
          message.data.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgUpdateMessage {
    const message = { ...baseMsgUpdateMessage } as MsgUpdateMessage;
    message.data = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = String(object.status);
    } else {
      message.status = "";
    }
    if (object.name !== undefined && object.name !== null) {
      message.name = String(object.name);
    } else {
      message.name = "";
    }
    if (object.data !== undefined && object.data !== null) {
      for (const e of object.data) {
        message.data.push(String(e));
      }
    }
    return message;
  },

  toJSON(message: MsgUpdateMessage): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    message.status !== undefined && (obj.status = message.status);
    message.name !== undefined && (obj.name = message.name);
    if (message.data) {
      obj.data = message.data.map((e) => e);
    } else {
      obj.data = [];
    }
    return obj;
  },

  fromPartial(object: DeepPartial<MsgUpdateMessage>): MsgUpdateMessage {
    const message = { ...baseMsgUpdateMessage } as MsgUpdateMessage;
    message.data = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = object.status;
    } else {
      message.status = "";
    }
    if (object.name !== undefined && object.name !== null) {
      message.name = object.name;
    } else {
      message.name = "";
    }
    if (object.data !== undefined && object.data !== null) {
      for (const e of object.data) {
        message.data.push(e);
      }
    }
    return message;
  },
};

const baseMsgUpdateMessageResponse: object = {};

export const MsgUpdateMessageResponse = {
  encode(
    _: MsgUpdateMessageResponse,
    writer: Writer = Writer.create()
  ): Writer {
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgUpdateMessageResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgUpdateMessageResponse,
    } as MsgUpdateMessageResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgUpdateMessageResponse {
    const message = {
      ...baseMsgUpdateMessageResponse,
    } as MsgUpdateMessageResponse;
    return message;
  },

  toJSON(_: MsgUpdateMessageResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgUpdateMessageResponse>
  ): MsgUpdateMessageResponse {
    const message = {
      ...baseMsgUpdateMessageResponse,
    } as MsgUpdateMessageResponse;
    return message;
  },
};

const baseMsgDeleteMessage: object = { creator: "", id: 0 };

export const MsgDeleteMessage = {
  encode(message: MsgDeleteMessage, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgDeleteMessage {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgDeleteMessage } as MsgDeleteMessage;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgDeleteMessage {
    const message = { ...baseMsgDeleteMessage } as MsgDeleteMessage;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgDeleteMessage): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(object: DeepPartial<MsgDeleteMessage>): MsgDeleteMessage {
    const message = { ...baseMsgDeleteMessage } as MsgDeleteMessage;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgDeleteMessageResponse: object = {};

export const MsgDeleteMessageResponse = {
  encode(
    _: MsgDeleteMessageResponse,
    writer: Writer = Writer.create()
  ): Writer {
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgDeleteMessageResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgDeleteMessageResponse,
    } as MsgDeleteMessageResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgDeleteMessageResponse {
    const message = {
      ...baseMsgDeleteMessageResponse,
    } as MsgDeleteMessageResponse;
    return message;
  },

  toJSON(_: MsgDeleteMessageResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgDeleteMessageResponse>
  ): MsgDeleteMessageResponse {
    const message = {
      ...baseMsgDeleteMessageResponse,
    } as MsgDeleteMessageResponse;
    return message;
  },
};

const baseMsgCreateL3Node: object = { creator: "", publicKey: "", options: "" };

export const MsgCreateL3Node = {
  encode(message: MsgCreateL3Node, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.publicKey !== "") {
      writer.uint32(18).string(message.publicKey);
    }
    for (const v of message.options) {
      writer.uint32(26).string(v!);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgCreateL3Node {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgCreateL3Node } as MsgCreateL3Node;
    message.options = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.publicKey = reader.string();
          break;
        case 3:
          message.options.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateL3Node {
    const message = { ...baseMsgCreateL3Node } as MsgCreateL3Node;
    message.options = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.publicKey !== undefined && object.publicKey !== null) {
      message.publicKey = String(object.publicKey);
    } else {
      message.publicKey = "";
    }
    if (object.options !== undefined && object.options !== null) {
      for (const e of object.options) {
        message.options.push(String(e));
      }
    }
    return message;
  },

  toJSON(message: MsgCreateL3Node): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.publicKey !== undefined && (obj.publicKey = message.publicKey);
    if (message.options) {
      obj.options = message.options.map((e) => e);
    } else {
      obj.options = [];
    }
    return obj;
  },

  fromPartial(object: DeepPartial<MsgCreateL3Node>): MsgCreateL3Node {
    const message = { ...baseMsgCreateL3Node } as MsgCreateL3Node;
    message.options = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.publicKey !== undefined && object.publicKey !== null) {
      message.publicKey = object.publicKey;
    } else {
      message.publicKey = "";
    }
    if (object.options !== undefined && object.options !== null) {
      for (const e of object.options) {
        message.options.push(e);
      }
    }
    return message;
  },
};

const baseMsgCreateL3NodeResponse: object = { id: 0 };

export const MsgCreateL3NodeResponse = {
  encode(
    message: MsgCreateL3NodeResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgCreateL3NodeResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgCreateL3NodeResponse,
    } as MsgCreateL3NodeResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateL3NodeResponse {
    const message = {
      ...baseMsgCreateL3NodeResponse,
    } as MsgCreateL3NodeResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgCreateL3NodeResponse): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgCreateL3NodeResponse>
  ): MsgCreateL3NodeResponse {
    const message = {
      ...baseMsgCreateL3NodeResponse,
    } as MsgCreateL3NodeResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgUpdateL3Node: object = {
  creator: "",
  id: 0,
  publicKey: "",
  options: "",
};

export const MsgUpdateL3Node = {
  encode(message: MsgUpdateL3Node, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    if (message.publicKey !== "") {
      writer.uint32(26).string(message.publicKey);
    }
    for (const v of message.options) {
      writer.uint32(34).string(v!);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgUpdateL3Node {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgUpdateL3Node } as MsgUpdateL3Node;
    message.options = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        case 3:
          message.publicKey = reader.string();
          break;
        case 4:
          message.options.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgUpdateL3Node {
    const message = { ...baseMsgUpdateL3Node } as MsgUpdateL3Node;
    message.options = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    if (object.publicKey !== undefined && object.publicKey !== null) {
      message.publicKey = String(object.publicKey);
    } else {
      message.publicKey = "";
    }
    if (object.options !== undefined && object.options !== null) {
      for (const e of object.options) {
        message.options.push(String(e));
      }
    }
    return message;
  },

  toJSON(message: MsgUpdateL3Node): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    message.publicKey !== undefined && (obj.publicKey = message.publicKey);
    if (message.options) {
      obj.options = message.options.map((e) => e);
    } else {
      obj.options = [];
    }
    return obj;
  },

  fromPartial(object: DeepPartial<MsgUpdateL3Node>): MsgUpdateL3Node {
    const message = { ...baseMsgUpdateL3Node } as MsgUpdateL3Node;
    message.options = [];
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    if (object.publicKey !== undefined && object.publicKey !== null) {
      message.publicKey = object.publicKey;
    } else {
      message.publicKey = "";
    }
    if (object.options !== undefined && object.options !== null) {
      for (const e of object.options) {
        message.options.push(e);
      }
    }
    return message;
  },
};

const baseMsgUpdateL3NodeResponse: object = {};

export const MsgUpdateL3NodeResponse = {
  encode(_: MsgUpdateL3NodeResponse, writer: Writer = Writer.create()): Writer {
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgUpdateL3NodeResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgUpdateL3NodeResponse,
    } as MsgUpdateL3NodeResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgUpdateL3NodeResponse {
    const message = {
      ...baseMsgUpdateL3NodeResponse,
    } as MsgUpdateL3NodeResponse;
    return message;
  },

  toJSON(_: MsgUpdateL3NodeResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgUpdateL3NodeResponse>
  ): MsgUpdateL3NodeResponse {
    const message = {
      ...baseMsgUpdateL3NodeResponse,
    } as MsgUpdateL3NodeResponse;
    return message;
  },
};

const baseMsgDeleteL3Node: object = { creator: "", id: 0 };

export const MsgDeleteL3Node = {
  encode(message: MsgDeleteL3Node, writer: Writer = Writer.create()): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgDeleteL3Node {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgDeleteL3Node } as MsgDeleteL3Node;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgDeleteL3Node {
    const message = { ...baseMsgDeleteL3Node } as MsgDeleteL3Node;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgDeleteL3Node): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(object: DeepPartial<MsgDeleteL3Node>): MsgDeleteL3Node {
    const message = { ...baseMsgDeleteL3Node } as MsgDeleteL3Node;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgDeleteL3NodeResponse: object = {};

export const MsgDeleteL3NodeResponse = {
  encode(_: MsgDeleteL3NodeResponse, writer: Writer = Writer.create()): Writer {
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgDeleteL3NodeResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgDeleteL3NodeResponse,
    } as MsgDeleteL3NodeResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgDeleteL3NodeResponse {
    const message = {
      ...baseMsgDeleteL3NodeResponse,
    } as MsgDeleteL3NodeResponse;
    return message;
  },

  toJSON(_: MsgDeleteL3NodeResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgDeleteL3NodeResponse>
  ): MsgDeleteL3NodeResponse {
    const message = {
      ...baseMsgDeleteL3NodeResponse,
    } as MsgDeleteL3NodeResponse;
    return message;
  },
};

const baseMsgCreateAttachedUser: object = {
  creator: "",
  iidapId: 0,
  account: 0,
  userName: "",
};

export const MsgCreateAttachedUser = {
  encode(
    message: MsgCreateAttachedUser,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.iidapId !== 0) {
      writer.uint32(16).int32(message.iidapId);
    }
    if (message.account !== 0) {
      writer.uint32(24).int32(message.account);
    }
    if (message.userName !== "") {
      writer.uint32(34).string(message.userName);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgCreateAttachedUser {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgCreateAttachedUser } as MsgCreateAttachedUser;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.iidapId = reader.int32();
          break;
        case 3:
          message.account = reader.int32();
          break;
        case 4:
          message.userName = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateAttachedUser {
    const message = { ...baseMsgCreateAttachedUser } as MsgCreateAttachedUser;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = Number(object.iidapId);
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = Number(object.account);
    } else {
      message.account = 0;
    }
    if (object.userName !== undefined && object.userName !== null) {
      message.userName = String(object.userName);
    } else {
      message.userName = "";
    }
    return message;
  },

  toJSON(message: MsgCreateAttachedUser): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.iidapId !== undefined && (obj.iidapId = message.iidapId);
    message.account !== undefined && (obj.account = message.account);
    message.userName !== undefined && (obj.userName = message.userName);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgCreateAttachedUser>
  ): MsgCreateAttachedUser {
    const message = { ...baseMsgCreateAttachedUser } as MsgCreateAttachedUser;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = object.iidapId;
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = object.account;
    } else {
      message.account = 0;
    }
    if (object.userName !== undefined && object.userName !== null) {
      message.userName = object.userName;
    } else {
      message.userName = "";
    }
    return message;
  },
};

const baseMsgCreateAttachedUserResponse: object = {};

export const MsgCreateAttachedUserResponse = {
  encode(
    _: MsgCreateAttachedUserResponse,
    writer: Writer = Writer.create()
  ): Writer {
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgCreateAttachedUserResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgCreateAttachedUserResponse,
    } as MsgCreateAttachedUserResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgCreateAttachedUserResponse {
    const message = {
      ...baseMsgCreateAttachedUserResponse,
    } as MsgCreateAttachedUserResponse;
    return message;
  },

  toJSON(_: MsgCreateAttachedUserResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgCreateAttachedUserResponse>
  ): MsgCreateAttachedUserResponse {
    const message = {
      ...baseMsgCreateAttachedUserResponse,
    } as MsgCreateAttachedUserResponse;
    return message;
  },
};

const baseMsgUpdateAttachedUser: object = {
  creator: "",
  iidapId: 0,
  account: 0,
  userName: "",
};

export const MsgUpdateAttachedUser = {
  encode(
    message: MsgUpdateAttachedUser,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.iidapId !== 0) {
      writer.uint32(16).int32(message.iidapId);
    }
    if (message.account !== 0) {
      writer.uint32(24).int32(message.account);
    }
    if (message.userName !== "") {
      writer.uint32(34).string(message.userName);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgUpdateAttachedUser {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgUpdateAttachedUser } as MsgUpdateAttachedUser;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.iidapId = reader.int32();
          break;
        case 3:
          message.account = reader.int32();
          break;
        case 4:
          message.userName = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgUpdateAttachedUser {
    const message = { ...baseMsgUpdateAttachedUser } as MsgUpdateAttachedUser;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = Number(object.iidapId);
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = Number(object.account);
    } else {
      message.account = 0;
    }
    if (object.userName !== undefined && object.userName !== null) {
      message.userName = String(object.userName);
    } else {
      message.userName = "";
    }
    return message;
  },

  toJSON(message: MsgUpdateAttachedUser): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.iidapId !== undefined && (obj.iidapId = message.iidapId);
    message.account !== undefined && (obj.account = message.account);
    message.userName !== undefined && (obj.userName = message.userName);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgUpdateAttachedUser>
  ): MsgUpdateAttachedUser {
    const message = { ...baseMsgUpdateAttachedUser } as MsgUpdateAttachedUser;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = object.iidapId;
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = object.account;
    } else {
      message.account = 0;
    }
    if (object.userName !== undefined && object.userName !== null) {
      message.userName = object.userName;
    } else {
      message.userName = "";
    }
    return message;
  },
};

const baseMsgUpdateAttachedUserResponse: object = {};

export const MsgUpdateAttachedUserResponse = {
  encode(
    _: MsgUpdateAttachedUserResponse,
    writer: Writer = Writer.create()
  ): Writer {
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgUpdateAttachedUserResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgUpdateAttachedUserResponse,
    } as MsgUpdateAttachedUserResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgUpdateAttachedUserResponse {
    const message = {
      ...baseMsgUpdateAttachedUserResponse,
    } as MsgUpdateAttachedUserResponse;
    return message;
  },

  toJSON(_: MsgUpdateAttachedUserResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgUpdateAttachedUserResponse>
  ): MsgUpdateAttachedUserResponse {
    const message = {
      ...baseMsgUpdateAttachedUserResponse,
    } as MsgUpdateAttachedUserResponse;
    return message;
  },
};

const baseMsgDeleteAttachedUser: object = {
  creator: "",
  iidapId: 0,
  account: 0,
};

export const MsgDeleteAttachedUser = {
  encode(
    message: MsgDeleteAttachedUser,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.iidapId !== 0) {
      writer.uint32(16).int32(message.iidapId);
    }
    if (message.account !== 0) {
      writer.uint32(24).int32(message.account);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgDeleteAttachedUser {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgDeleteAttachedUser } as MsgDeleteAttachedUser;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.iidapId = reader.int32();
          break;
        case 3:
          message.account = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgDeleteAttachedUser {
    const message = { ...baseMsgDeleteAttachedUser } as MsgDeleteAttachedUser;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = Number(object.iidapId);
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = Number(object.account);
    } else {
      message.account = 0;
    }
    return message;
  },

  toJSON(message: MsgDeleteAttachedUser): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.iidapId !== undefined && (obj.iidapId = message.iidapId);
    message.account !== undefined && (obj.account = message.account);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgDeleteAttachedUser>
  ): MsgDeleteAttachedUser {
    const message = { ...baseMsgDeleteAttachedUser } as MsgDeleteAttachedUser;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = object.iidapId;
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = object.account;
    } else {
      message.account = 0;
    }
    return message;
  },
};

const baseMsgDeleteAttachedUserResponse: object = {};

export const MsgDeleteAttachedUserResponse = {
  encode(
    _: MsgDeleteAttachedUserResponse,
    writer: Writer = Writer.create()
  ): Writer {
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgDeleteAttachedUserResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgDeleteAttachedUserResponse,
    } as MsgDeleteAttachedUserResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgDeleteAttachedUserResponse {
    const message = {
      ...baseMsgDeleteAttachedUserResponse,
    } as MsgDeleteAttachedUserResponse;
    return message;
  },

  toJSON(_: MsgDeleteAttachedUserResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgDeleteAttachedUserResponse>
  ): MsgDeleteAttachedUserResponse {
    const message = {
      ...baseMsgDeleteAttachedUserResponse,
    } as MsgDeleteAttachedUserResponse;
    return message;
  },
};

const baseMsgCreateRollupDigest: object = {
  creator: "",
  dsUri: "",
  currentHash: "",
  status: "",
};

export const MsgCreateRollupDigest = {
  encode(
    message: MsgCreateRollupDigest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.dsUri !== "") {
      writer.uint32(18).string(message.dsUri);
    }
    if (message.currentHash !== "") {
      writer.uint32(26).string(message.currentHash);
    }
    if (message.status !== "") {
      writer.uint32(34).string(message.status);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgCreateRollupDigest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgCreateRollupDigest } as MsgCreateRollupDigest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.dsUri = reader.string();
          break;
        case 3:
          message.currentHash = reader.string();
          break;
        case 4:
          message.status = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateRollupDigest {
    const message = { ...baseMsgCreateRollupDigest } as MsgCreateRollupDigest;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = String(object.dsUri);
    } else {
      message.dsUri = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = String(object.currentHash);
    } else {
      message.currentHash = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = String(object.status);
    } else {
      message.status = "";
    }
    return message;
  },

  toJSON(message: MsgCreateRollupDigest): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.dsUri !== undefined && (obj.dsUri = message.dsUri);
    message.currentHash !== undefined &&
      (obj.currentHash = message.currentHash);
    message.status !== undefined && (obj.status = message.status);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgCreateRollupDigest>
  ): MsgCreateRollupDigest {
    const message = { ...baseMsgCreateRollupDigest } as MsgCreateRollupDigest;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = object.dsUri;
    } else {
      message.dsUri = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = object.currentHash;
    } else {
      message.currentHash = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = object.status;
    } else {
      message.status = "";
    }
    return message;
  },
};

const baseMsgCreateRollupDigestResponse: object = { id: 0 };

export const MsgCreateRollupDigestResponse = {
  encode(
    message: MsgCreateRollupDigestResponse,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgCreateRollupDigestResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgCreateRollupDigestResponse,
    } as MsgCreateRollupDigestResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgCreateRollupDigestResponse {
    const message = {
      ...baseMsgCreateRollupDigestResponse,
    } as MsgCreateRollupDigestResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgCreateRollupDigestResponse): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgCreateRollupDigestResponse>
  ): MsgCreateRollupDigestResponse {
    const message = {
      ...baseMsgCreateRollupDigestResponse,
    } as MsgCreateRollupDigestResponse;
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgUpdateRollupDigest: object = {
  creator: "",
  id: 0,
  dsUri: "",
  currentHash: "",
  status: "",
};

export const MsgUpdateRollupDigest = {
  encode(
    message: MsgUpdateRollupDigest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    if (message.dsUri !== "") {
      writer.uint32(26).string(message.dsUri);
    }
    if (message.currentHash !== "") {
      writer.uint32(34).string(message.currentHash);
    }
    if (message.status !== "") {
      writer.uint32(42).string(message.status);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgUpdateRollupDigest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgUpdateRollupDigest } as MsgUpdateRollupDigest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        case 3:
          message.dsUri = reader.string();
          break;
        case 4:
          message.currentHash = reader.string();
          break;
        case 5:
          message.status = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgUpdateRollupDigest {
    const message = { ...baseMsgUpdateRollupDigest } as MsgUpdateRollupDigest;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = String(object.dsUri);
    } else {
      message.dsUri = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = String(object.currentHash);
    } else {
      message.currentHash = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = String(object.status);
    } else {
      message.status = "";
    }
    return message;
  },

  toJSON(message: MsgUpdateRollupDigest): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    message.dsUri !== undefined && (obj.dsUri = message.dsUri);
    message.currentHash !== undefined &&
      (obj.currentHash = message.currentHash);
    message.status !== undefined && (obj.status = message.status);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgUpdateRollupDigest>
  ): MsgUpdateRollupDigest {
    const message = { ...baseMsgUpdateRollupDigest } as MsgUpdateRollupDigest;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = object.dsUri;
    } else {
      message.dsUri = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = object.currentHash;
    } else {
      message.currentHash = "";
    }
    if (object.status !== undefined && object.status !== null) {
      message.status = object.status;
    } else {
      message.status = "";
    }
    return message;
  },
};

const baseMsgUpdateRollupDigestResponse: object = {};

export const MsgUpdateRollupDigestResponse = {
  encode(
    _: MsgUpdateRollupDigestResponse,
    writer: Writer = Writer.create()
  ): Writer {
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgUpdateRollupDigestResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgUpdateRollupDigestResponse,
    } as MsgUpdateRollupDigestResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgUpdateRollupDigestResponse {
    const message = {
      ...baseMsgUpdateRollupDigestResponse,
    } as MsgUpdateRollupDigestResponse;
    return message;
  },

  toJSON(_: MsgUpdateRollupDigestResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgUpdateRollupDigestResponse>
  ): MsgUpdateRollupDigestResponse {
    const message = {
      ...baseMsgUpdateRollupDigestResponse,
    } as MsgUpdateRollupDigestResponse;
    return message;
  },
};

const baseMsgDeleteRollupDigest: object = { creator: "", id: 0 };

export const MsgDeleteRollupDigest = {
  encode(
    message: MsgDeleteRollupDigest,
    writer: Writer = Writer.create()
  ): Writer {
    if (message.creator !== "") {
      writer.uint32(10).string(message.creator);
    }
    if (message.id !== 0) {
      writer.uint32(16).uint64(message.id);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): MsgDeleteRollupDigest {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseMsgDeleteRollupDigest } as MsgDeleteRollupDigest;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.creator = reader.string();
          break;
        case 2:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MsgDeleteRollupDigest {
    const message = { ...baseMsgDeleteRollupDigest } as MsgDeleteRollupDigest;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    return message;
  },

  toJSON(message: MsgDeleteRollupDigest): unknown {
    const obj: any = {};
    message.creator !== undefined && (obj.creator = message.creator);
    message.id !== undefined && (obj.id = message.id);
    return obj;
  },

  fromPartial(
    object: DeepPartial<MsgDeleteRollupDigest>
  ): MsgDeleteRollupDigest {
    const message = { ...baseMsgDeleteRollupDigest } as MsgDeleteRollupDigest;
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    return message;
  },
};

const baseMsgDeleteRollupDigestResponse: object = {};

export const MsgDeleteRollupDigestResponse = {
  encode(
    _: MsgDeleteRollupDigestResponse,
    writer: Writer = Writer.create()
  ): Writer {
    return writer;
  },

  decode(
    input: Reader | Uint8Array,
    length?: number
  ): MsgDeleteRollupDigestResponse {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = {
      ...baseMsgDeleteRollupDigestResponse,
    } as MsgDeleteRollupDigestResponse;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(_: any): MsgDeleteRollupDigestResponse {
    const message = {
      ...baseMsgDeleteRollupDigestResponse,
    } as MsgDeleteRollupDigestResponse;
    return message;
  },

  toJSON(_: MsgDeleteRollupDigestResponse): unknown {
    const obj: any = {};
    return obj;
  },

  fromPartial(
    _: DeepPartial<MsgDeleteRollupDigestResponse>
  ): MsgDeleteRollupDigestResponse {
    const message = {
      ...baseMsgDeleteRollupDigestResponse,
    } as MsgDeleteRollupDigestResponse;
    return message;
  },
};

/** Msg defines the Msg service. */
export interface Msg {
  CreateRollup(request: MsgCreateRollup): Promise<MsgCreateRollupResponse>;
  UpdateRollup(request: MsgUpdateRollup): Promise<MsgUpdateRollupResponse>;
  DeleteRollup(request: MsgDeleteRollup): Promise<MsgDeleteRollupResponse>;
  CreateMessage(request: MsgCreateMessage): Promise<MsgCreateMessageResponse>;
  UpdateMessage(request: MsgUpdateMessage): Promise<MsgUpdateMessageResponse>;
  DeleteMessage(request: MsgDeleteMessage): Promise<MsgDeleteMessageResponse>;
  CreateL3Node(request: MsgCreateL3Node): Promise<MsgCreateL3NodeResponse>;
  UpdateL3Node(request: MsgUpdateL3Node): Promise<MsgUpdateL3NodeResponse>;
  DeleteL3Node(request: MsgDeleteL3Node): Promise<MsgDeleteL3NodeResponse>;
  CreateAttachedUser(
    request: MsgCreateAttachedUser
  ): Promise<MsgCreateAttachedUserResponse>;
  UpdateAttachedUser(
    request: MsgUpdateAttachedUser
  ): Promise<MsgUpdateAttachedUserResponse>;
  DeleteAttachedUser(
    request: MsgDeleteAttachedUser
  ): Promise<MsgDeleteAttachedUserResponse>;
  CreateRollupDigest(
    request: MsgCreateRollupDigest
  ): Promise<MsgCreateRollupDigestResponse>;
  UpdateRollupDigest(
    request: MsgUpdateRollupDigest
  ): Promise<MsgUpdateRollupDigestResponse>;
  /** this line is used by starport scaffolding # proto/tx/rpc */
  DeleteRollupDigest(
    request: MsgDeleteRollupDigest
  ): Promise<MsgDeleteRollupDigestResponse>;
}

export class MsgClientImpl implements Msg {
  private readonly rpc: Rpc;
  constructor(rpc: Rpc) {
    this.rpc = rpc;
  }
  CreateRollup(request: MsgCreateRollup): Promise<MsgCreateRollupResponse> {
    const data = MsgCreateRollup.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "CreateRollup",
      data
    );
    return promise.then((data) =>
      MsgCreateRollupResponse.decode(new Reader(data))
    );
  }

  UpdateRollup(request: MsgUpdateRollup): Promise<MsgUpdateRollupResponse> {
    const data = MsgUpdateRollup.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "UpdateRollup",
      data
    );
    return promise.then((data) =>
      MsgUpdateRollupResponse.decode(new Reader(data))
    );
  }

  DeleteRollup(request: MsgDeleteRollup): Promise<MsgDeleteRollupResponse> {
    const data = MsgDeleteRollup.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "DeleteRollup",
      data
    );
    return promise.then((data) =>
      MsgDeleteRollupResponse.decode(new Reader(data))
    );
  }

  CreateMessage(request: MsgCreateMessage): Promise<MsgCreateMessageResponse> {
    const data = MsgCreateMessage.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "CreateMessage",
      data
    );
    return promise.then((data) =>
      MsgCreateMessageResponse.decode(new Reader(data))
    );
  }

  UpdateMessage(request: MsgUpdateMessage): Promise<MsgUpdateMessageResponse> {
    const data = MsgUpdateMessage.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "UpdateMessage",
      data
    );
    return promise.then((data) =>
      MsgUpdateMessageResponse.decode(new Reader(data))
    );
  }

  DeleteMessage(request: MsgDeleteMessage): Promise<MsgDeleteMessageResponse> {
    const data = MsgDeleteMessage.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "DeleteMessage",
      data
    );
    return promise.then((data) =>
      MsgDeleteMessageResponse.decode(new Reader(data))
    );
  }

  CreateL3Node(request: MsgCreateL3Node): Promise<MsgCreateL3NodeResponse> {
    const data = MsgCreateL3Node.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "CreateL3Node",
      data
    );
    return promise.then((data) =>
      MsgCreateL3NodeResponse.decode(new Reader(data))
    );
  }

  UpdateL3Node(request: MsgUpdateL3Node): Promise<MsgUpdateL3NodeResponse> {
    const data = MsgUpdateL3Node.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "UpdateL3Node",
      data
    );
    return promise.then((data) =>
      MsgUpdateL3NodeResponse.decode(new Reader(data))
    );
  }

  DeleteL3Node(request: MsgDeleteL3Node): Promise<MsgDeleteL3NodeResponse> {
    const data = MsgDeleteL3Node.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "DeleteL3Node",
      data
    );
    return promise.then((data) =>
      MsgDeleteL3NodeResponse.decode(new Reader(data))
    );
  }

  CreateAttachedUser(
    request: MsgCreateAttachedUser
  ): Promise<MsgCreateAttachedUserResponse> {
    const data = MsgCreateAttachedUser.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "CreateAttachedUser",
      data
    );
    return promise.then((data) =>
      MsgCreateAttachedUserResponse.decode(new Reader(data))
    );
  }

  UpdateAttachedUser(
    request: MsgUpdateAttachedUser
  ): Promise<MsgUpdateAttachedUserResponse> {
    const data = MsgUpdateAttachedUser.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "UpdateAttachedUser",
      data
    );
    return promise.then((data) =>
      MsgUpdateAttachedUserResponse.decode(new Reader(data))
    );
  }

  DeleteAttachedUser(
    request: MsgDeleteAttachedUser
  ): Promise<MsgDeleteAttachedUserResponse> {
    const data = MsgDeleteAttachedUser.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "DeleteAttachedUser",
      data
    );
    return promise.then((data) =>
      MsgDeleteAttachedUserResponse.decode(new Reader(data))
    );
  }

  CreateRollupDigest(
    request: MsgCreateRollupDigest
  ): Promise<MsgCreateRollupDigestResponse> {
    const data = MsgCreateRollupDigest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "CreateRollupDigest",
      data
    );
    return promise.then((data) =>
      MsgCreateRollupDigestResponse.decode(new Reader(data))
    );
  }

  UpdateRollupDigest(
    request: MsgUpdateRollupDigest
  ): Promise<MsgUpdateRollupDigestResponse> {
    const data = MsgUpdateRollupDigest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "UpdateRollupDigest",
      data
    );
    return promise.then((data) =>
      MsgUpdateRollupDigestResponse.decode(new Reader(data))
    );
  }

  DeleteRollupDigest(
    request: MsgDeleteRollupDigest
  ): Promise<MsgDeleteRollupDigestResponse> {
    const data = MsgDeleteRollupDigest.encode(request).finish();
    const promise = this.rpc.request(
      "cosmonaut.voter.voter.Msg",
      "DeleteRollupDigest",
      data
    );
    return promise.then((data) =>
      MsgDeleteRollupDigestResponse.decode(new Reader(data))
    );
  }
}

interface Rpc {
  request(
    service: string,
    method: string,
    data: Uint8Array
  ): Promise<Uint8Array>;
}

declare var self: any | undefined;
declare var window: any | undefined;
var globalThis: any = (() => {
  if (typeof globalThis !== "undefined") return globalThis;
  if (typeof self !== "undefined") return self;
  if (typeof window !== "undefined") return window;
  if (typeof global !== "undefined") return global;
  throw "Unable to locate global object";
})();

type Builtin = Date | Function | Uint8Array | string | number | undefined;
export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function longToNumber(long: Long): number {
  if (long.gt(Number.MAX_SAFE_INTEGER)) {
    throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
  }
  return long.toNumber();
}

if (util.Long !== Long) {
  util.Long = Long as any;
  configure();
}
