package cli

import (
	"fmt"
	// "strings"

	"github.com/spf13/cobra"

	"github.com/cosmos/cosmos-sdk/client"
	// "github.com/cosmos/cosmos-sdk/client/flags"
	// sdk "github.com/cosmos/cosmos-sdk/types"

	"github.com/cosmonaut/voter/x/voter/types"
)

// GetQueryCmd returns the cli query commands for this module
func GetQueryCmd(queryRoute string) *cobra.Command {
	// Group voter queries under a subcommand
	cmd := &cobra.Command{
		Use:                        types.ModuleName,
		Short:                      fmt.Sprintf("Querying commands for the %s module", types.ModuleName),
		DisableFlagParsing:         true,
		SuggestionsMinimumDistance: 2,
		RunE:                       client.ValidateCmd,
	}

	cmd.AddCommand(CmdListRollup())
	cmd.AddCommand(CmdShowRollup())
	cmd.AddCommand(CmdListMessage())
	cmd.AddCommand(CmdShowMessage())
	cmd.AddCommand(CmdListL3Node())
	cmd.AddCommand(CmdShowL3Node())
	cmd.AddCommand(CmdListAttachedUser())
	cmd.AddCommand(CmdShowAttachedUser())
	cmd.AddCommand(CmdListRollupDigest())
	cmd.AddCommand(CmdShowRollupDigest())
	// this line is used by starport scaffolding # 1

	return cmd
}
