package types

import (
	"github.com/cosmos/cosmos-sdk/codec"
	cdctypes "github.com/cosmos/cosmos-sdk/codec/types"
	sdk "github.com/cosmos/cosmos-sdk/types"
	"github.com/cosmos/cosmos-sdk/types/msgservice"
)

func RegisterCodec(cdc *codec.LegacyAmino) {
	cdc.RegisterConcrete(&MsgCreateRollup{}, "voter/CreateRollup", nil)
	cdc.RegisterConcrete(&MsgUpdateRollup{}, "voter/UpdateRollup", nil)
	cdc.RegisterConcrete(&MsgDeleteRollup{}, "voter/DeleteRollup", nil)
	cdc.RegisterConcrete(&MsgCreateMessage{}, "voter/CreateMessage", nil)
	cdc.RegisterConcrete(&MsgUpdateMessage{}, "voter/UpdateMessage", nil)
	cdc.RegisterConcrete(&MsgDeleteMessage{}, "voter/DeleteMessage", nil)
	cdc.RegisterConcrete(&MsgCreateL3Node{}, "voter/CreateL3Node", nil)
	cdc.RegisterConcrete(&MsgUpdateL3Node{}, "voter/UpdateL3Node", nil)
	cdc.RegisterConcrete(&MsgDeleteL3Node{}, "voter/DeleteL3Node", nil)
	cdc.RegisterConcrete(&MsgCreateAttachedUser{}, "voter/CreateAttachedUser", nil)
	cdc.RegisterConcrete(&MsgUpdateAttachedUser{}, "voter/UpdateAttachedUser", nil)
	cdc.RegisterConcrete(&MsgDeleteAttachedUser{}, "voter/DeleteAttachedUser", nil)
	cdc.RegisterConcrete(&MsgCreateRollupDigest{}, "voter/CreateRollupDigest", nil)
	cdc.RegisterConcrete(&MsgUpdateRollupDigest{}, "voter/UpdateRollupDigest", nil)
	cdc.RegisterConcrete(&MsgDeleteRollupDigest{}, "voter/DeleteRollupDigest", nil)
	// this line is used by starport scaffolding # 2
}

func RegisterInterfaces(registry cdctypes.InterfaceRegistry) {
	registry.RegisterImplementations((*sdk.Msg)(nil),
		&MsgCreateRollup{},
		&MsgUpdateRollup{},
		&MsgDeleteRollup{},
	)
	registry.RegisterImplementations((*sdk.Msg)(nil),
		&MsgCreateMessage{},
		&MsgUpdateMessage{},
		&MsgDeleteMessage{},
	)
	registry.RegisterImplementations((*sdk.Msg)(nil),
		&MsgCreateL3Node{},
		&MsgUpdateL3Node{},
		&MsgDeleteL3Node{},
	)
	registry.RegisterImplementations((*sdk.Msg)(nil),
		&MsgCreateAttachedUser{},
		&MsgUpdateAttachedUser{},
		&MsgDeleteAttachedUser{},
	)
	registry.RegisterImplementations((*sdk.Msg)(nil),
		&MsgCreateRollupDigest{},
		&MsgUpdateRollupDigest{},
		&MsgDeleteRollupDigest{},
	)
	// this line is used by starport scaffolding # 3

	msgservice.RegisterMsgServiceDesc(registry, &_Msg_serviceDesc)
}

var (
	amino     = codec.NewLegacyAmino()
	ModuleCdc = codec.NewProtoCodec(cdctypes.NewInterfaceRegistry())
)
